
/*
   <report>
   <name>  Sample Report </name>
   <desc>  Descrption of the Report says what is does and who may need to use it. </desc>
   <param name="PARAM1" default = "" type="1"  />  // type can be [0-3]
   <param name="PARAM2" default = "" type="2"  />
   ...
   <sql name="cmd1"> SELECT * FROM DEAL </sql>
   <sql name="cmd2"> SELECT * FROM DEAL </sql>
   ...
   <result_desc>
       <col> junk1</col>
       <col> junk2 </col>
       <col> junk3 </col>
       <tabname> Deals </tabname>
   </result_desc>
   <result_desc>
       <col> junk4 </col>
       <col> junk5 </col>
       <col> junk6 </col>
       <tabname> Yields </tabname>
   </result_desc>
</report>
 */


package net.sourceforge.asse;

import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.Hashtable;
import javax.swing.table.TableModel;


class AReport {
    
    final String   name;
    String         desc;
    Vector         params;  //Type Param
    Vector         sql;    //Type String sql commands
    
    Hashtable      tab_title; // Result set titles by unique column.
    Hashtable      col_format; // column format
    Hashtable      col_format_type; // column format : There are three types : INT, DECIMAL, DATE
    
    public AReport(String pname, String description ) {
        name  = pname;
        desc  = description;
        params = new Vector();
        sql   = new Vector();
        tab_title = new Hashtable();
        col_format = new Hashtable();
        col_format_type = new Hashtable();
        
    }
    
    public void addSql( String cmd) {
        if (cmd != null)
            sql.add(cmd);
    }
    public void addParam( Param p) {
        if (p != null)
            params.add(p);
    }
    
    public String getResultName( TableModel tbl) {// Returns the title if all columns match
        Object o1;
        for (int j = 0; j < tbl.getColumnCount(); j++) {
            o1 = tab_title.get(tbl.getColumnName(j));
            if (o1 != null)
                return o1.toString();
        }
        return  null;
    }
    
    public String getFormat(String colname) {
        Object o1 = col_format.get(colname);
        if (o1 != null)
            return o1.toString();
        return null;
    }
    
    public void setFormat(String column, String fmt) {
        col_format.put(column, fmt);
    }
    
    public Class getFormatType(String colname) {
        Object o1 = col_format_type.get(colname);
        
        if (o1 != null)
            try {
                return Class.forName(o1.toString());
            }
            catch (Exception ex) {
                ;
            }
        return null;
    }
    public void setFormatType(String col, String typ) {
        col_format_type.put(col, typ);
    }
    
    public void setTableName( String col, String table ) {
        tab_title.put(col, table);
    }
    
    public String getTableName(String col) {
        Object o1 = tab_title.get(col);
        if (o1 == null)
            return null;
        
        return o1.toString();
    }
    
    public String[] getSql() {
            
            String x[] = new String[sql.size()];
            
            return (String []) sql.toArray(x);
        }
        
        public Param[] getParams() {
            
            Param[] x = new Param[params.size()];
            return (Param []) params.toArray(x);
            
        }
        
        public String getDesc() {
            return desc;
        }
        
        public String getName() {
            return name;
        }
        
        
        public String toString() {
            
            StringBuffer sbuff = new StringBuffer();
            
            sbuff.append("Name:" + name + "\n");
            sbuff.append("Desc:" + desc + "\n");
            
            Iterator itr = sql.iterator();
            while (itr.hasNext())
                sbuff.append("SQL:" + itr.next().toString() + "\n");
            
            itr = params.iterator();
            while (itr.hasNext())
                sbuff.append("Param:" + itr.next().toString() + "\n");
            
            return sbuff.toString();
            
        }
    }
