
// Provides Persistence via asse.dat which stores
// various settings related to the gui (window sizes/column widths),

package net.sourceforge.asse;

import java.io.*;
import java.util.*;

class AsseGlobal {

    public static Hashtable  colwidths;// stores column-name=>initial width map
    public static Hashtable  colformats; // stores column formats
    
    static Properties props;     // bunch of properties
    public static Vector recentFiles;
    public static Vector recentTables;
    public static Vector recentReports;
    public static Hashtable dbprofiles;

    private AsseGlobal() {
    }

    public static void init(String basename ) {
	
	pstore_file = System.getProperty("user.home") +
	    File.separator +  basename;
	try {
	    pstore.load(pstore_file);
	    
	    Object obj = pstore.get("ColumnWidths");
	    if (obj == null || !(obj instanceof Hashtable))
		colwidths = new Hashtable();
	    else
		colwidths = (Hashtable)obj;

            obj = pstore.get("ColumnFormats");
	    if (obj == null || !(obj instanceof Hashtable))
		colformats = new Hashtable();
	    else
		colformats = (Hashtable)obj;

	    obj = pstore.get("Properties");
	    if (obj == null || !(obj instanceof Properties))
		props = new Properties();
	    else
		props = (Properties)obj;

	    obj = pstore.get("MRUFiles");
	    if (obj == null || !(obj instanceof Vector))
		recentFiles = new Vector();
	    else
		recentFiles = (Vector)obj;

	    obj = pstore.get("MRUTables");
	    if (obj == null || !(obj instanceof Vector))
		recentTables = new Vector();
	    else
		recentTables = (Vector)obj;

	    obj = pstore.get("MRUReports");
	    if (obj == null || !(obj instanceof Vector))
		recentReports = new Vector();
	    else
		recentReports = (Vector)obj;

            obj = pstore.get("DBProfiles");
            if (obj == null || !(obj instanceof Hashtable)) 
                dbprofiles = new Hashtable();
            else
                dbprofiles = (Hashtable)obj;
                
	    DwbjProps.init(props);

	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}

    }
    
    public static void shutdown() {
	try {
	    pstore.put("ColumnWidths",colwidths);
	    pstore.put("Properties",  props);
	    pstore.put("MRUFiles", recentFiles);
	    pstore.put("MRUTables", recentTables);
	    pstore.put("MRUReports", recentReports);
            pstore.put("DBProfiles", dbprofiles);

	    pstore.save(pstore_file);
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }

    private static PersistentStore pstore = new PersistentStore();
    private static String  pstore_file;

}




















