package net.sourceforge.asse;

// This class continously executes SQL requests
// being received into the queue.
import java.sql.*;

class DBExecutor extends Thread {
    
    DBQueue dbq;
    DBMulti dbm;
    DBMultiListener dbl;

    public DBExecutor( DBQueue q, DBMulti m, DBMultiListener l)  {

	dbq = q;
	dbm = m;
	dbl = l;
    }

    public void run () {
	
	while (true) {

	    DBQResult dbqr = new DBQResult();
	    try {
		Integer jobid = dbq.getJobId();
		String sql = dbq.getJob(jobid);
		dbqr.cmd = sql;
		dbqr.rowcount = 0;
		if (sql == null) {
		    System.out.println(" Job with jobid = " + 
				       jobid + " is null.\n");

		    dbq.addRes (jobid, dbqr);
		} else {
		   
		    try {
			dbqr.ezt_array = dbm.executeQuery (sql, dbl);
			dbqr.rowcount = dbm.last_rowcount();
			dbq.addRes(jobid, dbqr);
		    }
		    catch (SQLException sqle) {
			dbqr.sqle = sqle;
			dbq.addRes(jobid, dbqr);
		    }
		}
	    } catch (InterruptedException ex) {
		ex.printStackTrace();
		try { 
		    dbm.cancelQuery();
		} catch (SQLException e1) {
		    e1.printStackTrace();
		}
	    }

	}
    }

    public void close() {
	try { 
	    dbm.cancelQuery();
	    dbm.close();
	} catch (SQLException e1) {
	    e1.printStackTrace();
	}

    }
}

