package net.sourceforge.asse;

// add your custom import statements here
import java.io.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.logging.*;

    
import com.sybase.jdbcx.*;

// This is a connection class which can handle multiple 
// result sets during execution.

public class DBMulti  implements SybMessageHandler  { 

    public final static Object sync_lock = new Object();

    public static void main  (String args[]) {
	
        try {
	    DBMulti x = new DBMulti("");
	    x.set_debug(true);
	    for (int i = 0; i < args.length; i++) {
		
		ezTable who[] = x.executeQuery( args[i] ); 		
		if (who != null) {
		    for (int j =0; j < who.length; j++) {
			who[j].print();
		    }
		} // else
		// 		System.out.println("Nothing came back from executeQuery()");
	    }
        } catch ( Exception t ) {
            System.err.println( "Uncaught exception "+t );
	    //   ErrorLog.saveError(t);
            t.printStackTrace();
        }
    }
    
    public DBMulti(String proxy) {
	//  	this ("192.168.0.13", "5000",  "mshah", "mshah1", proxy);	//home
  	//this ("199.242.2.19", "2050", "mshah", "", proxy); // SYBDBC
	this ("localhost", "4100",  "mshah", "mshahmshah", proxy);	//home
  	//this ("localhost", "5005", "mshah", "", proxy); // SYBDBC
    }

    // The following functions for anyone wishing to 'hear' all the SQL
    public void addDBMultiSqlListener ( DBMultiSqlListener x ) {
	sql_listeners.add(x);
    }
	
    public void removeDBMultiSqlListener( DBMultiSqlListener x) {
	sql_listeners.remove(x);
    }

    private void tellSqlToListeners(String sql) {
	Iterator it = sql_listeners.iterator();
	while(it.hasNext()) {
	    ((DBMultiSqlListener) it.next()).sql_to_execute(sql);
	}
    }

    // The following three allow you to listen to all messages
    // from the server
    public void addDBMultiMsgListener ( DBMultiMsgListener x ) {
	msg_listeners.add(x);
    }
	
    public void removeDBMultiMsgListener( DBMultiMsgListener x) {
	msg_listeners.remove(x);
    }

    // Required for SybMessageHandler
    public SQLException messageHandler(SQLException sqe)
    {
	
	Iterator it = msg_listeners.iterator();
	while(it.hasNext()) {
	    ((DBMultiMsgListener) it.next()).msg_from_server(sqe.getMessage());
	}

	return sqe;
    }

    public DBMulti(String host, String port, 
		   String user, String passwd) {

	this(host, port, user, passwd, "");
    }

    public DBMulti(DBMulti a) {
	this (a.l_host, a.l_port, a.l_user, a.l_passwd, a.l_proxy_url);
    }

    public DBMulti(String host, String port, 
		   String user, String passwd, String proxy_url) {
	this (host, port, user, passwd, proxy_url, "noname");
    }

    public DBMulti(String host, String port, 
		   String user, String passwd, String proxy_url,
		   String appname) {

	l_host = host;
	l_port = port;
	l_user = user;
	l_passwd = passwd;
	l_proxy_url = proxy_url;

	try {
	    SybDriver sybDriver = (SybDriver)
		Class.forName
		("com.sybase.jdbc2.jdbc.SybDriver").newInstance();
	    sybDriver.setVersion
		(com.sybase.jdbcx.SybDriver.VERSION_5);
	    DriverManager.registerDriver(sybDriver);
	
	    sybDriver.setSybMessageHandler(this);

	    Properties props = new Properties();
	    props.put("user", user);
	    props.put("password", passwd);
	    props.put("APPLICATIONNAME", appname);
	    props.put("HOSTPROC", "27021993");
	    props.put("HOSTNAME",
		      java.net.InetAddress.getLocalHost().getHostName());
	    props.put("IGNORE_DONE_IN_PROC", "true");
	    /*
	     * If the program is an applet that wants to access
	     * a server that is not on the same host as the
	     * web server, then it uses a proxy gateway.
	     */
	    if (proxy_url != null && proxy_url.length() > 0) {
		props.put("proxy", proxy_url); // "localhost:8000");
	    }

	    props.put("USE_METADATA", "false");
	    /*
	     * Make sure you set connection properties before
	     * attempting to make a connection. You can also
	     * set the properties in the URL.
	     */
	
	    String url = "jdbc:sybase:Tds:" + host + ":" + port;
	    connection = DriverManager.getConnection
		(url, props);
	    
	    // 	    System.out.println("connected to database");
	    statement = connection.createStatement();
	    
	} 
	catch (Exception ex) {
            Logger logger = Logger.getLogger("asse");
            logger.log(Level.SEVERE,"DBERROR",ex);
	    connection = null;
	}
    }
    
    public void cancelQuery() throws SQLException {
	if (statement != null)
	    statement.cancel();
    }

    public Connection get_connection() {
	return connection;
    }
    
    public int executeUpdate(String cmd)  throws SQLException {
	logger_sql.log(Level.INFO,cmd);
	return  statement.executeUpdate(cmd);
    }

    public void set_debug(boolean flag) {
	flag_debug = flag;
    }

    public ezTable[] executeQuery(String query) 
	throws SQLException  

    {
	return executeQuery(query, null);
    }

    private int last_rows_affected = 0;

    public int last_rowcount() {
	return last_rows_affected;
    }

    public ezTable[] executeQuery(String query, DBMultiListener dbl) 
	throws SQLException  
    {
	if (connection.isClosed()) {
	  
            logger_sql.log(Level.SEVERE, "No Database connection. Reconnect !");
            JOptionPane.showMessageDialog(null,
					  "Please reconnect or exit",
					  "DB Connection is dead",
					  JOptionPane.ERROR_MESSAGE);
	    //assemdi_frame.get().setDefCursor();
	    return null;
	}
	
	Vector tbl_vector = new Vector();
	ezTable[]  tablearray = null;
	DefaultTableModel  tbl;
	ezTable  eztbl;
	int  rsnum = 0;
	
	last_rows_affected = 0;

        logger_sql.log(Level.INFO, query);
        
	try {
	    
	    boolean results = statement.execute(query);
	    

	    int rows_affected;

	    do	{
		if (results) {
		    ResultSet rslt = statement.getResultSet();
		    rsnum++;
		    
		    getEzData(rslt, dbl, tbl_vector);
                    //log_warnings(rslt.getWarnings());
		    if (rsnum >= 10) {
			if (dbl == null ||
			    dbl.cancel_on_too_many_results(tbl_vector.size())) {
			    break;
			}
			rsnum = 0;
		    }
		    rslt.close();
		} 
		rows_affected = statement.getUpdateCount();
                if (rows_affected >= 0) {
                    last_rows_affected = rows_affected;
                    logger_sql.log(Level.INFO,"Rows affected " + rows_affected);
                }
		    
		results = statement.getMoreResults();
                log_warnings(statement.getWarnings());
		statement.clearWarnings();
	    }
	    while (results || rows_affected != -1);

	}
	catch (SQLException ex) {      
            log_warnings(ex);
            if (!(ex instanceof java.sql.SQLWarning))
                if (tbl_vector.size() == 0)
                    throw ex;
	}

	tablearray = new ezTable[ tbl_vector.size() ];
	tbl_vector.copyInto(tablearray);      
	
	return tablearray;
    }

    private void log_warnings(SQLException ex) {
        if (ex == null)
            return;
        logger_sql.log(Level.WARNING,ex.getMessage(),ex);
        SQLException next;
        next = ex.getNextException();
        while (next != null) {
            logger_sql.log(Level.WARNING,next.getMessage(),next);
            next = next.getNextException();
        }  
    }
private void getEzData(ResultSet rslt, DBMultiListener dbl,
			      Vector tblvec )
	throws SQLException 
    {

	ResultSetMetaData  rs_meta = rslt.getMetaData();
	int numCols = rs_meta.getColumnCount();
	
	Vector columnNames = new Vector( numCols );
 	Vector columnTypes  = new Vector( numCols);
	
	for(int column = 0; column < numCols; column++) {
	    String x1 =rs_meta.getColumnLabel(column+1);
	    x1 = x1.trim();
	    if (x1.length() == 0) {
		x1 = new String("col-" + (column + 1));
	    }
	    columnNames.insertElementAt(x1, column);
	    String x2 =rs_meta.getColumnTypeName(column+1);
	    columnTypes.insertElementAt (x2, column);
//  	    System.out.println( "column:"  + x1 + " type:" + x2 );
	}

	ezTable ezt = new ezTable( new Vector(), columnNames, columnTypes );
//  	ezTable ezt = new ezTable( new Vector(), columnNames);
	tblvec.add(ezt);

	// Get now get rows
	int row_counter = 0;
        int max_rows = 1000;

//        try {
            while(rslt.next()) {
                Object[] row = new Object[numCols];
                for (int i = 1; i <= numCols; i++)
                    row[i - 1] = rslt.getObject(i);
                
                
                ezt.addRow(row);
                row_counter++;
                if (row_counter >= max_rows) {
                    if (dbl == null ||
                    dbl.cancel_on_too_many_rows( ezt.getRowCount())) {
                        break;
                    }
                    row_counter = 0;
                    max_rows *= 2;
                }
            }
//        }
     
//  	catch (SQLException ex) {
//  	    if (!(ex instanceof com.sybase.jdbc2.jdbc.SybSQLWarning)) {
//  		throw ex;
//  	    }
//  	    screwit = true;
//  	}
	

    }

    public void dont_tell(boolean val) {
	dont_tell = val;
    }

    public void close() throws SQLException {
	if (! connection.isClosed() ) {
	    System.out.println("Closing db connection");
	    connection.close();
	}
    }
    
//    static private void printExceptions(SQLException sqe)
//    {
//	while (sqe != null)
//	    {
//		System.out.println(
//				   "SqlState: " + sqe.getSQLState()  +
//				   " " + sqe.toString() +
//				   ", ErrorCode: " + sqe.getErrorCode() +
//				   " : " + sqe.getMessage());
//		
//		sqe = sqe.getNextException();
//	    }
//    }


    // add your data members here
    String           l_host;
    String           l_port;
    String           l_user;
    String           l_passwd;
    String           l_proxy_url;

    SybDriver        sybDRiver;
    Connection      connection;
    Statement        statement;
    Class[]            columnTpyes = {};
    Vector	           rows = new Vector();
    boolean          flag_debug = false;
    HashSet        sql_listeners = new HashSet();
    HashSet        msg_listeners = new HashSet();
    boolean        dont_tell = false;
    private static Logger logger_sql = Logger.getLogger("asse.sql");
    //DefaultTableModel   retdata;
    // add your data members here
}




