/*
 * DBSchema.java
 *
 * Created on August 5, 2004, 10:53 PM
 */

package net.sourceforge.asse;

import java.util.*;
import java.io.*;

/**
 *
 * @author  Manish Shah
 */
public class DBSchema {
    /** Creates a new instance of DBSchema */
    
    
    /** Creates a new instance of DBSchema */
    public DBSchema() {
        String o[] = get_objs("select db_name() ");
        curdb = o[0];
        
      /*
      D = default
      F = SQLJ function
      L = log
      P = Transact-SQL or SQLJ procedure
      PR = prepare objects (created by Dynamic SQL)
      R = rule
      RI = referential constraint
      S = system table
      TR = trigger
      U = user table
      V = view
      XP = extended stored procedure
       */
        
        if (type2obj_map.size() < 1) {
            type2obj_map.put("U", "Tables");
            type2obj_map.put("V", "Views");
            type2obj_map.put("P", "Procedures");
            type2obj_map.put("TR", "Triggers");
            type2obj_map.put("R", "Rules");
            type2obj_map.put("D", "Defaults");
//            type2obj_map.put("S", "SystemProc");
            
//            Enumeration e = type2obj_map.keys();
//            while (e.hasMoreElements()) {
//                Object o1 = e.nextElement();
//                obj2type_map.put( type2obj_map.get(o1), o1);
//            }
        }
    }
    
    private String[] get_objs(String sql_cmd) {
        Vector dbobjs = new Vector();
        String [] arr;
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            if (res.length == 1) {
                for (int i = 0; i < res[0].getRowCount(); i++)
                    dbobjs.add( res[0].getString(i,0));
            }
            arr = new String[dbobjs.size()];
            for (int i = 0; i < dbobjs.size(); i++)
                arr[i] = (String)dbobjs.get(i);
            return arr;
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
        }
        arr = new String[0];
        return arr;
    }
    public String get_curdb() {
        return curdb;
        
    }
    
    public String[] get_dbs() {
        
        return get_objs("select name from master..sysdatabases where name not in ('dbccdb', 'master', " +
        "'model', 'sybsystemprocs', 'sybsystemdb') and name not like 'temp%' order by name");
    }
    
    public String [] get_Types() {
        String [] otypes = new String [ type2obj_map.size()];
        int i = 0;
        Enumeration k = type2obj_map.keys();
        while (k.hasMoreElements()) {
            otypes[i++] = k.nextElement().toString();
        }
        return otypes;
    }
    
    public String get_TypeName(String type) {
        Object o1 = type2obj_map.get(type);
        if (o1 != null)
            return o1.toString();
        else
            return null;
    }
    
    public String [] get_objects(String type) {
      
        return get_objs("select user_name(uid) + '.' + name from "
                        + curdb 
                        + "..sysobjects where type = '" 
                        + type + "' order by user_name(uid) + '.' + name");
    }
    public String [] get_objects_search(String type, String wildcard) {
        
        return get_objs("select user_name(uid) + '.' + name from "
                        + curdb 
                        + "..sysobjects  " 
                        + " where type = '" +  type + "' and name like '%" + wildcard + "%' order by user_name(uid) + '.' + name");
                        
    }
    
    
    public String get_help( String dbname, String otype, String oname) {
        
        StringBuffer buf = new StringBuffer();
        buf.append("<HTML> <body><H2>" + dbname + "." + oname + "</H2>\n");
        
        if (otype.equals("Tables") ||
        otype.equals("Views") ) {
            buf.append(get_helpTable(dbname, oname));
        }
        
        if(!otype.equals("Tables")) {
            buf.append("<HR>");
            buf.append(get_helpText(dbname, oname));
        }
        String protection = get_helpProtect(dbname, oname);
        if (protection.length() > 0)
            buf.append("<HR>").append(protection);
        buf.append("</body>\n</html>");
        return buf.toString();
    }
    public String searchObjects( String pattern) {
        
        String sql_cmd;
        
        sql_cmd =  "select case when type = 'U' then 'Table'  when type = 'P' then 'Procedure' when type = 'V' then 'View' when type = 'TR' then 'Trigger' when type = 'R' then 'Rule' else type end 'Type' " +
        " , user_name(uid) 'Owner', name 'Object'" +
        " from " +
        curdb + "..sysobjects where name like " +  "'%" + pattern + "%'" +
        "order by type,  user_name(uid), name";
        
        
        StringBuffer buf = new StringBuffer();
        
        
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            ezTable   cols;
            buf.append("<HTML> <body><H2>" + pattern + " Search </H2>\n");
            
            for (int resid = 0; resid < res.length; resid++ ) {
                
                ByteArrayOutputStream bstream = new ByteArrayOutputStream();
                PrintStream prn = new PrintStream(bstream);
                res[resid].printHtmlTable(prn);
                buf.append(bstream.toString());
                
            }
            buf.append("</body></html>");
            return buf.toString();
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
            return "";
        }
        
    }
    public String searchFields( String pattern) {
        
        String sql_cmd;
        
        sql_cmd =   "select case when a.type = 'U' then 'Table'  when a.type = 'P' then 'Procedure' when a.type = 'V' then 'View' when a.type = 'TR' then 'Trigger' when a.type = 'R' then 'Rule' else a.type end 'Type' " +
        ", user_name(a.uid) 'Owner', a.name 'Object', b.name 'Column' " +
        " from " + curdb + "..sysobjects a, " + curdb + "..syscolumns b " +
        "  where a.id = b.id and b.name like " +  "'%" + pattern + "%'" +
        " order by a.type, user_name(a.uid), a.name, b.name ";
        
        
        StringBuffer buf = new StringBuffer();
        
        
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            ezTable   cols;
            buf.append("<HTML> <body><H2>" + pattern + " Search </H2>\n");
            
            for (int resid = 0; resid < res.length; resid++ ) {
                
                ByteArrayOutputStream bstream = new ByteArrayOutputStream();
                PrintStream prn = new PrintStream(bstream);
                res[resid].printHtmlTable(prn);
                buf.append(bstream.toString());
                
            }
            buf.append("</body></html>");
            return buf.toString();
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
            return "";
        }
        
    }
    
    public String get_helpTable( String dbname, String oname) {
        
        String sql_cmd;
        
        StringBuffer buf = new StringBuffer();
        StringBuffer select = new StringBuffer();
        
        sql_cmd = dbname + "..sp_help '" + oname + "'";
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            ezTable   cols;
            
            select.append("<TABLE ><TR><TH> SELECT </TH>");
            String delimiter = "";
            for (int resid = 0; resid < res.length; resid++ ) {
                if (res[resid].findColumn("Owner") >= 0)
                    continue;
                if (res[resid].findColumn("exp_row_size") >= 0)
                    continue;
                if (res[resid].findColumn("concurrency_opt_threshold") >= 0)
                    continue;
                if (res[resid].findColumn("Column_name") >= 0) {
                    select.append("<TR><TD> SELECT ");
                    cols = res[resid];
                    for (int i = 0; i < cols.getRowCount(); i++) {
                        int j = i + 1;
                        select.append(delimiter).append( cols.getString(i, "Column_name"));
                        delimiter = ", ";
                    }
                    select.append("\n FROM ").append(oname);
                    select.append("</TR></TD></TABLE>");
                }
                ByteArrayOutputStream bstream = new ByteArrayOutputStream();
                PrintStream prn = new PrintStream(bstream);
                res[resid].printHtmlTable(prn);
                buf.append(bstream.toString());
                prn.close();
                
            }
            buf.append("<HR>").append(select);
            return buf.toString();
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
            return "";
        }
        
    }
    public String get_helpText( String dbname, String oname) {
        
        String sql_cmd;
        StringBuffer buf = new StringBuffer();
        buf.append("<PRE>\n");
        
        sql_cmd = dbname + "..sp_helptext '" +  oname + "'";
        
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            
            if (res.length < 2)
                return "";
            for (int i = 1; i < res.length; i++) {
                for (int j = 0; j < res[i].getRowCount(); j++) {
                    String txt = res[i].getString(j,"text");
                    txt = txt.replaceAll("\n$","");
                    txt = txt.replaceAll("<","&#060;");
                    buf.append(txt);
                }
            }
            buf.append("\n</PRE>\n");
            return buf.toString();
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
        }
        return "";
    }
    public String get_helpProtect( String dbname, String oname) {
        
        String sql_cmd;
        
        StringBuffer buf = new StringBuffer();
        sql_cmd = dbname + "..sp_helprotect '" + oname + "'";
        try {
            ezTable[] res = asse.dbq.executeQuery(sql_cmd);
            for (int resid = 0; resid < res.length; resid++ ) {
                
                if (res[resid].getRowCount() < 1)
                    continue;
                
                ByteArrayOutputStream bstream = new ByteArrayOutputStream();
                PrintStream prn = new PrintStream(bstream);
                res[resid].printHtmlTable(prn);
                buf.append(bstream.toString());
                prn.close();
                
            }
            return buf.toString();
        }
        catch (java.sql.SQLException ex) {
            ex.printStackTrace();
            return "";
        }
        
    }
    String curdb;
    static Hashtable type2obj_map = new Hashtable();
//    static Hashtable obj2type_map = new Hashtable();
}

