package net.sourceforge.asse;

import java.io.*;
import java.util.Properties;;

class DwbjProps  {

    static Properties props;

    public static void init (Properties p) {
	if (props == null) {
	    props = p;
	}
    }

    public static String getProperty (String key, String def) {
	return props.getProperty(key, def);
    }

    public static String getProperty (String key) {
	return props.getProperty(key);
    }

    public static float  getFloatProperty(String key) {
	return getFloatProperty(key, 0);
    }
    public static float  getFloatProperty(String key, float def) {
	String strx = props.getProperty(key);
	if (strx == null) {
	    return def;
	}

	try {
	    return Float.parseFloat(strx);
	}
	catch (NumberFormatException ex) {
	    System.out.println(" value for key " + key + "  is not an float." );
	}
	return def;
    }

    public static int  getIntProperty(String key) {
	return getIntProperty(key, 0);
    }
    public static int  getIntProperty(String key, int def) {
	String strx = props.getProperty(key);
	if (strx == null) {
	    return def;
	}

	try {
	    return Integer.parseInt(strx);
	}
	catch (NumberFormatException ex) {
	    System.out.println(" value for key " + key + "  is not an integer." );
	}
	return def;
    }

    public static Object setProperty(String key, String value) {
	return props.setProperty(key, value);
    }

    public static void setFloatProperty(String key, float value) {
	props.setProperty (key, Float.toString(value));
    }
    public static void setIntProperty(String key, int value) {
	props.setProperty(key, Integer.toString(value));
    }

    public static void remove(String key) {
	props.remove(key);
    }
}
