package net.sourceforge.asse;

import java.util.*;

class DwbjServer {

    String login;
    String password;
    String host;
    String port;
    String name; // logical name

    public DwbjServer (String pserver, String plogin, String ppassword, 
		       String phost, String pport) {
	name = pserver;
	login = plogin;
	password = ppassword;
	host = phost;
	port = pport;
    }

    public DwbjServer (String servername, boolean toinit) {
	name = servername;
	if (toinit) {
	    initFromProps();
	}
    }

    public void initFromProps () {
	
	login = DwbjProps.getProperty(name + ":login", "");
	password = DwbjProps.getProperty(name + ":password", "");
	host = DwbjProps.getProperty(name + ":host", "");
	port = DwbjProps.getProperty(name + ":port", "");

    }

    public void saveToProps() {
	DwbjProps.setProperty(name + ":login", login);
	DwbjProps.setProperty(name + ":password", password);
	DwbjProps.setProperty(name + ":host", host);
	DwbjProps.setProperty(name + ":port", port);
    }

    public void removeFromProps() {
	DwbjProps.remove(name + ":login");
	DwbjProps.remove(name + ":password");
	DwbjProps.remove(name + ":host");
	DwbjProps.remove(name + ":port");
    }
	
    public String getName() {
	return name;
    }
    
    public String getLogin() {
	return login;
    }

    public void setLogin(String plogin) {
	login = plogin;
    }
    
    public String getPassword() {
	return password;
    }

    public void setPassword(String ppassword) {
	password = ppassword;
    }
    
    public String getHost() {
	return host;
    }

    public void setHost(String phost) {
	host = phost;
    }

    public String getPort() {
	return port;
    }

    public void setPort(String pport) {
	port = pport;
    }

    public static DwbjServer[] loadServers () {

	Vector v =  new Vector();
	DwbjServer ds;
	String sname;

	for (int i = 0; i < 10; i++) {
	    String serverN = new String("SERVER-" + i);
	    sname = DwbjProps.getProperty(serverN);
	    if (sname != null) {
		ds = new DwbjServer(sname, true);
		v.add(ds);
	    }
	}

	DwbjServer darray[] = new DwbjServer [ v.size() ];
	v.copyInto(darray);

	return darray;
    }
	
    public static void unloadServers () {

	DwbjServer ds;
	for (int i = 0; i < 10; i++) {
	    String serverN = new String("SERVER-" + i);
	    String sname = DwbjProps.getProperty(serverN);
	    DwbjProps.remove(serverN);

	    if (sname != null) {
		ds = new DwbjServer(sname, true);
		ds.removeFromProps();
	    }
	}
    }

}
	
	
