package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


class ErrDialog  extends JDialog implements ActionListener {

    public ErrDialog (String title, Exception ex) {
	this(assemdi_frame.get(), title, ex.getMessage());
	ex.printStackTrace();
    }

    public ErrDialog (String title, String error) {
	this(title, error, true);
    }

    public ErrDialog (String title, String error, boolean traceError) {
	this(assemdi_frame.get(), title, error);
	if (traceError)
	    System.out.println(error);
    }

    public ErrDialog (JFrame frame, String title, String error) {
	this(frame, title, error, "ErrDialog");
    }
    public ErrDialog (JFrame frame, String title, String error, 
		      String sizekeyp ) {

	super (frame, title, true);
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	getContentPane().setLayout( new BorderLayout());
	jt = new JTextArea();
	jt.setText(error);
	jt.setLineWrap(true);
	jt.setEnabled(false);

	{
	    JScrollPane j = new JScrollPane(jt);
	    j.setPreferredSize(new Dimension(100,100));
	    j.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	    this.getContentPane().add(j, BorderLayout.CENTER);
	}
	    

	okbutton = new JButton("OK");
	okbutton.addActionListener(this);	

	sizekey = sizekeyp;
	setSize(	DwbjProps.getIntProperty(sizekey + "width", 200),
		DwbjProps.getIntProperty(sizekey + "height", 200));
    
	this.getContentPane().add(okbutton, BorderLayout.SOUTH);
	getRootPane().setDefaultButton(okbutton);
	setLocationRelativeTo(frame);
	this.show();
    }

    protected void processWindowEvent(WindowEvent e) {

        if (e.getID() == WindowEvent.WINDOW_CLOSING)   {
	    DwbjProps.setIntProperty(sizekey + "width", getWidth());
	    DwbjProps.setIntProperty(sizekey + "height", getHeight());
	}
    
        super.processWindowEvent(e);
    }

    public void actionPerformed (ActionEvent ae) {

	WindowEvent we = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
	this.dispatchEvent(we);
    }
	
    JTextArea jt;
    JButton     okbutton;
    String      sizekey; 
    static int            sheight =0;
    static int            swidth =0;

    public static void main(String argv[]) {

	myframe fm = new testframe ("JDialog Test");
	fm.setSize(500, 500);
	fm.setVisible(true);
    }

    
}
    
class testframe extends myframe implements ActionListener  {
	public void actionPerformed(ActionEvent ae) {
	    
	    ErrDialog ed = new ErrDialog( this, "ERROR", 
					  "this is the most annoying error message that you have ever seen in any window.");
	}
	public  testframe(String title) {
	    super (title);
	    JButton jb = new JButton("OK");
	    jb.addActionListener(this);
	    getContentPane().add(jb);
	};
    };
