

package net.sourceforge.asse;

import java.io.File;
import java.io.IOException;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.undo.*;

class JSQLFrame extends asseInternalFrame 
    implements ActionListener {

    public JSQLFrame (File sqlfile) 
    throws IOException {
        
        setMenuItem("RUN", Boolean.TRUE);
       
        setMenuItem("Print Table", Boolean.TRUE);
        setMenuItem("Save Table As...", Boolean.TRUE);
        setMenuItem("Print Report", Boolean.TRUE);
        setMenuItem("File Save", Boolean.TRUE);
        setMenuItem("File Save As...", Boolean.TRUE);
        setMenuItem("Insert Query From...", Boolean.TRUE);
        setMenuItem("Show as Plain Text", Boolean.TRUE);
        setMenuItem("Print SQL", Boolean.TRUE);
        setMenuItem("Undo", Boolean.TRUE);
        setMenuItem("Redo", Boolean.TRUE);
        setMenuItem("Stop", Boolean.TRUE);
        setMenuItem("Run", Boolean.TRUE);
        
	initComponents(sqlfile);
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	addInternalFrameListener( new InternalFrameAdapter() {
		public void internalFrameClosing(InternalFrameEvent e) {
		    jsqlp.saveSQLonExit();
		}
	    } );
            
    }

    private void initComponents (File new_sqlfile) throws IOException {
	sqlfile = new_sqlfile;
	setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setClosable(true);
	setTitle("ISQL:"+sqlfile.getCanonicalPath());

	{ 

	    asseundo = new asseUndo(this);
	    
	}

	jsqlp = new JSQLPane(this, sqlfile, asseundo);
	getContentPane().add(jsqlp, java.awt.BorderLayout.CENTER);

        pack();
    }

    public void setFile(File f) {
        sqlfile = f;
        try {
            setTitle("ISQL:" + sqlfile.getCanonicalPath());
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    // Used to ID this frame.
    public File getFile() {
	return sqlfile;
    }

    public void actionPerformed(ActionEvent ae) {
	jsqlp.actionPerformed(ae);
    }

//    JMenuBarEx menuBar;
    JSQLPane jsqlp;
    File     sqlfile;
    asseUndo asseundo;

}
