package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;
import java.io.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JFileChooser.*;
import javax.swing.table.*;
import javax.swing.undo.*;
import javax.swing.event.UndoableEditListener;

public class JSQLPane extends JSplitPane
implements ActionListener, DBResultListener {
//implements DocumentListener, ActionListener, DBResultListener {
    
    TabbedTablePane      tabbedpane;
    JTextArea            jt;
    JScrollPane          jsp;
    String               last_command = "";
    File                 persistent_sqlfile;
    String               sql_to_run;
    JComboBox            combo;
    SqlNResults          snr = new SqlNResults();
    JCheckBox            chkbox;
    ActionListener       chkbox_listener, combo_listener;
    JButtonPanel         bp;
    Integer              jobid;
    boolean              flag_executing = false;
    JLabel               status_bar;
    JSQLFrame            sqlframe;
    final asseUndo             asseundo;
    
    
    public JSQLPane(JSQLFrame jf, File sqlfile, asseUndo aundo) {
        
        
        super(JSplitPane.VERTICAL_SPLIT, true);
        sqlframe = jf;
        persistent_sqlfile = sqlfile;
        
        asseundo = aundo;
        
        JPanel  topPanel = new JPanel();
        topPanel.setLayout( new BorderLayout() );
        jt = new JTextArea() {
            public boolean isFocusable() {
                return true;
            }
        };
        
        jsp = new JScrollPane(jt);
        jsp.setPreferredSize(new Dimension(500,200));
        topPanel.add( jsp, BorderLayout.CENTER);
        
        //jt.getDocument().addDocumentListener(this);
        this.setTopComponent(topPanel);
        
        jt.getDocument().addUndoableEditListener(
        new UndoableEditListener() {
            public void undoableEditHappened(UndoableEditEvent e){
                //Remember the edit and update the menus
                asseundo.addEdit(e.getEdit());
            };
        }
        );
        
        tabbedpane = new TabbedTablePane();
        tabbedpane.setPreferredSize(new Dimension(500,200));
        
        // Add button bars
        String[] buttonlist = {"Run", "Stop"};
        bp = new JButtonPanel(buttonlist);
        setRunMenu(true);
        
        bp.addActionListener(assemdi_frame.get());
        combo = new JComboBox();
        combo.setEditable(false);
        bp.add(combo);
        
        combo.addActionListener(combo_listener = new comboListener());
        
        chkbox  = new JCheckBox("Lock", false);
        bp.add(chkbox);
        
        chkbox.addActionListener(chkbox_listener = new chkboxListener());
        
        JPanel bottomPane = new JPanel(new BorderLayout());
        status_bar = new JLabel("STATUS");
        tabbedpane.set_statusbar(status_bar);
        
        bottomPane.add(bp, BorderLayout.NORTH);
        bottomPane.add(tabbedpane, BorderLayout.CENTER);
        bottomPane.add(status_bar, BorderLayout.SOUTH);
        
        this.setBottomComponent(bottomPane);
        
        readSQLfromFile(persistent_sqlfile, true);
        
        //all of the following to add a newline
        //if the last line is a 'go'
        try {
            BufferedReader br =
            new BufferedReader(new StringReader(jt.getText()));
            String line, lastline = null;
            while ((line = br.readLine()) != null)
                lastline = line;
            
            if ((lastline != null) &&
            (lastline.compareTo("go") == 0)) {
                jt.append("\n");
                jt.setCaretPosition(jt.getText().length());
            }
            
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public void saveSQLonExit() {
        saveSQLtoFile(persistent_sqlfile);
    }
    
    public void actionPerformed(ActionEvent ae) {
        
        String whatsup = ae.getActionCommand();
        
        try {
            if (whatsup.compareTo("Run") ==0) {
                
                String sql =  LocateCommand.find(jt.getText(),
                jt.getCaretPosition());
                if (sql.length() > 0)  {
                    execute_command(sql);
                }
                
                return;
            } else if (whatsup.compareTo("CopyTable") ==0) {
                
                ExcelAdapter.copy_to_excel( getJTable() );
                return;
            } else if (whatsup.equals("CopyKeys")) {
                int row = getJTable().getSelectedRow();
                if (row < 0 && getTable().getRowCount() > 0) {
                    row = 0;
                    getJTable().getSelectionModel().setSelectionInterval(0,0);
                }
                    
                if (row >= 0)
                        ExcelAdapter.copy_keys(row, tabbedpane.getCurrentTable());               
                return;
            } else if (whatsup.equals("Print Table")) {
                
                Utilities.printTable( getJTable() );
                return;
                
            } else if (whatsup.equals("Save Table As...")) {
                
                Utilities.save_table(getTable());
                return;
                
            } else if (whatsup.equals("Copy") ||
            whatsup.equals("Paste") ||
            whatsup.equals("Cut")) {
                Utilities.do_copycutpaste(whatsup);
            } else if (whatsup.compareTo("Stop") ==0) {
                
                if (asse.dbq.cancelJob(jobid)) {
                    setRunMenu(true);
                    flag_executing = false;
                }
                
                return;
            } else if (whatsup.compareTo("File Save") ==0) {
                
                //File  sqlfile = PickFile.promptForSQLFile("Save To");
                //if (sqlfile != null)
                //    saveSQLtoFile(sqlfile);
                saveSQLonExit();
            } else  if (whatsup.compareTo("File Save As...") ==0) {
                
                File  sqlfile = PickFile.promptForSQLFile("Save As");
                if (sqlfile != null) {
                    saveSQLtoFile(sqlfile);
                    persistent_sqlfile = sqlfile;
                    sqlframe.setFile(sqlfile);
                }
                assemdi_frame.get().refresh_windowmenu();
                
            } else if (whatsup.compareTo("Insert Query From...") == 0) {
                File  sqlfile = PickFile.promptForSQLFile("Read From");
                if (sqlfile != null)
                    readSQLfromFile(sqlfile, false);
            } else if (whatsup.equals("Show as Plain Text")) {
                
                int tabcount = tabbedpane.getTabCount();
                
                if (tabcount > 0) {
                    ByteArrayOutputStream x = new ByteArrayOutputStream();
                    
                    try {
                        
                        TableModel tm;
                        for (int tabnum = 0; tabnum < tabcount; tabnum++) {
                            
                            tm = tabbedpane.getTableAt(tabnum);
                            PrintTableModel.print(tm,
                            new PrintStream(x));
                        }
                        
                        new ErrDialog(assemdi_frame.get(),
                        "Plain Text", x.toString(),
                        "ShowPlainText");
                    }
                    catch (Exception ex) {
                        new ErrDialog("Save FAILED",ex);
                    }
                }
                //  	    } else if (whatsup.compareTo("Insert Query From ..") == 0) {
                //  		File  sqlfile = PickFile.promptForSQLFile("Read From");
                //  		if (sqlfile != null)
                //  		    readSQLfromFile(sqlfile, true);
            } else if (whatsup.compareTo("Print SQL") == 0) {
                new PrintAnyText(jt.getText());
            } else if (whatsup.indexOf("Select") == 0 &&
            whatsup.length() == 7) {
                int tabnum = 0;
                try {
                    tabnum = Integer.parseInt(whatsup.substring(6)) - 1;
                } catch (Exception ex) {
                    ;
                }
                if (tabnum  < tabbedpane.getTabCount())
                    tabbedpane.setSelectedIndex(tabnum);
                
            } else if (whatsup.indexOf("Undo") == 0 ) {
                asseundo.undo();
            } else if (whatsup.indexOf("Redo") == 0 ) {
                asseundo.redo();
            } else
                JOptionPane.showInternalMessageDialog(this,
                "This event is not programmed yet.",
                whatsup,
                JOptionPane.INFORMATION_MESSAGE);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        //assemdi_frame.get().setDefCursor();
    }
    
    // Document Listner Intefrace
//    public void changedUpdate(DocumentEvent e) {
//    }
//    public void removeUpdate(DocumentEvent e) {
//    }
//    public void insertUpdate(DocumentEvent e) {
//        if (e.getType() != DocumentEvent.EventType.INSERT)
//            return;
//        
//        Document doc = e.getDocument();
//        String   lastchar;
//        
//        try {
//            last_command = "";
//            lastchar = doc.getText(e.getOffset(), e.getLength());
//            if (!lastchar.equals("\n"))
//                return;
//            
//            String sql;
//            
//            if ((e.getOffset() > 0 &&
//            doc.getText(e.getOffset() -1,1).equals(";")) ||
//            (e.getOffset() > 1 &&
//            doc.getText(e.getOffset() -2,2).equals("go")))
//                sql =  LocateCommand.find(jt.getText(),
//                jt.getCaretPosition());
//            else
//                return;
//            
//            if (!sql.equals("")) {
//                execute_command(sql);
//            }
//            
//        } catch (BadLocationException badex) {
//            badex.printStackTrace();
//        }
//        
//    }
    
    // This is to implement DBResultListener
    //
    TableModel            blank_model;
    public void processResult( final DBQResult dbqr ) {
        
        final JSQLPane xpane = this;
        Runnable dbjob
        = new Runnable() {
            public void run() {
                
                boolean flag_norez = true;
                if (dbqr.ezt_array != null) {
                    ezTable[] res = dbqr.ezt_array;
                    for (int tbl = 0; tbl < res.length; tbl++) {
                        if (res[tbl].getRowCount() > 0) {
                            snr.add(dbqr.cmd , res);
                            reload_combo();
                            flag_norez = false;
                            break;
                        }
                    }
                }
                if (flag_norez)
                    update_status("No rows returned. Rows affected: "
                    + dbqr.rowcount);
                
                if (dbqr.sqle != null)
                    new ErrDialog( "DATABASE ERROR",  dbqr.sqle );
                
                setRunMenu(true);
                flag_executing = false;
            }
        };
        
        SwingUtilities.invokeLater(dbjob);
    }
    
    public void execute_command(final String command) {
        
        if (flag_executing)
            return;
        
        flag_executing = true;
        setRunMenu(false);
        
        update_status("Running..");
        
        final JSQLPane xpane = this;
        
        Runnable dbjob = new Runnable() {
            public void run() {
                jobid = asse.dbq.addJob(command, xpane);
            }
        };
        
        SwingUtilities.invokeLater(dbjob);
    }
    
    private void readSQLfromFile(File sqlfile, boolean insert) {
        
        if (sqlfile != null)
            try {
                FileReader in = new FileReader(sqlfile);
                StringWriter out = new StringWriter();
                int ch;
                while ((ch = in.read())>= 0)
                    out.write(ch);
                
                if (insert) {
                    int position = jt.getCaretPosition();
                    String total = jt.getText();
                    StringBuffer sb = new StringBuffer();
                    sb.append(total.substring(0, position));
                    sb.append(out.getBuffer());
                    sb.append(total.substring(position));
                    jt.setText(sb.toString());
                    jt.setCaretPosition( position + out.getBuffer().length());
                } else
                    jt.setText(out.toString());
                
                out.close();
                in.close();
            } catch (Exception ex) {
                ex.printStackTrace();
            }
    }
    
    public void scrollDownSQLPane() {
        JScrollBar jscb = jsp.getVerticalScrollBar();
        jscb.setValue(jscb.getMaximum());
    }
    
    public myJDBCAdapter getTable() {
        return tabbedpane.getCurrentTable();
    }
    public JTableRowHeader getJTable() {
        return tabbedpane.getCurrentJTable();
    }
    
    private void saveSQLtoFile(File sqlfile) {
        
        try {
            FileWriter out = new FileWriter(sqlfile);
            StringReader in = new StringReader(jt.getText());
            int ch;
            while ((ch = in.read())>= 0)
                out.write(ch);
            
            out.close();
            in.close();
        } catch (Exception ex) {
            new ErrDialog("Save FAILD", ex);
        }
    }
    
    public  void update_status(String status) {
        status_bar.setText(status);
    }
    
    private void reload_combo() {
        
        boolean reverse = true;
        String[] tags = snr.get_tags(reverse);
        
        combo.setEnabled(false);
        combo.removeAllItems();
        for (int i = 0; i < tags.length; i++)
            combo.insertItemAt(tags[i], i);
        
        combo.setSelectedIndex(0);
        combo.setEnabled(true);
    }
    
    class comboListener implements ActionListener {
        public comboListener() {}
        public void actionPerformed(ActionEvent e) {
            String tag = (String)combo.getSelectedItem();
            if (tag != null) {
                ezTable[] results = snr.get_res(tag);
                if (results != null) {
                    tabbedpane.addTables(results);
                    chkbox.removeActionListener( chkbox_listener );
                    if (snr.is_locked(tag))
                        chkbox.setSelected(true);
                    else
                        chkbox.setSelected(false);
                    chkbox.addActionListener( chkbox_listener );
                    combo.setToolTipText(snr.get_sql(tag).replace('\n',' '));
                }
            }
        }
    }
    
    class chkboxListener implements ActionListener {
        public chkboxListener() {}
        public void actionPerformed(ActionEvent e) {
            
            boolean selected  = chkbox.isSelected();
            combo.removeActionListener(combo_listener);
            
            String tag = (String)combo.getSelectedItem();
            if (tag != null) {
                int    tagindex = combo.getSelectedIndex();
                combo.removeItem(tag);
                snr.set_lock(tag, selected);
                tag = snr.get_tag(tag);
                combo.insertItemAt(tag, tagindex);
                combo.setSelectedIndex(tagindex);
            }
            
            combo.addActionListener(combo_listener);
            
        }
    }
    private void setRunMenu(boolean value) {
        bp.setEnabled("Run", value);
        bp.setEnabled("Stop",  value ? false : true);
        sqlframe.setMenuItem("Run", new Boolean(value));
        sqlframe.setMenuItem("Stop", new Boolean(value ? false : true));
        sqlframe.refreshMenu();
    }
}
