package net.sourceforge.asse;
import java.awt.*;
import java.math.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.text.*;
import java.util.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.*;
import java.awt.datatransfer.*;

public class JTablePane extends JSplitPane
    implements ActionListener, DBResultListener  {

    JTextArea             jt;
    JTableRowHeader       jtable;
    String                table_name = "none";
    TableInfo             table_info;
    JlistParams           param_panel;
    ChangeEvent           chg_event = new ChangeEvent(this);
    myJDBCAdapter         jadapter;
//      TableModel            blank_model;
    JComboBox             combo;
    JButtonPanel          bp;
    JLabel                status_bar;
    Runnable              statusjob;
//    JMenuBarEx            jme;
    boolean               flag_executing;
    Integer               jobid;
    JTableFrame           jtf;
    
    public JTablePane(JTableFrame jf, TableInfo new_tableinfo)  {

	super(JSplitPane.VERTICAL_SPLIT, true);

        jtf = jf;
        //jme.addActionListener(this);
	table_info = new_tableinfo;
	table_name = table_info.getTableName();
	
	Param [] cols = new Param [table_info.get_columnCount()];
	for (int i=0; i < cols.length; i++) {
	    String col_default = "";
	    String col_name = table_info.get_columnName( i+1 );
	    cols[i] = new Param (col_name, col_default);
	}
  	param_panel = new JlistParams(cols);
  	{
  	    JScrollPane j = new JScrollPane(param_panel);
  	    j.setPreferredSize(new Dimension(500,200));
  	    this.setTopComponent(j);	
  	}
	
	jtable = new JTableRowHeader();
//  	blank_model = jtable.getModel();
	{
	    ListSelectionModel rowSM;
	    rowSM = jtable.getSelectionModel();
	    rowSM.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
	    rowSM.addListSelectionListener(   new ListSelectionListener() {
		    public void valueChanged(ListSelectionEvent e) {
			update_status();
		    }
		} );
	}

	jtable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);

	JScrollPane j1 = jtable.getScrollPane();
	//this.setBottomComponent(j1);	

	//Add button bars
	String[] buttonlist = {"Run","Stop", "Insert", "Delete", 
			        "Commit", "Duplicate Rows", "Undo"};
        bp = new JButtonPanel(buttonlist);
	bp.addActionListener(assemdi_frame.get());

	JPanel bottomPane = new JPanel(new BorderLayout());
	status_bar = new JLabel("Status");
	bottomPane.setPreferredSize(new Dimension(500,200));
	bottomPane.add(bp, BorderLayout.NORTH);
	bottomPane.add(j1, BorderLayout.CENTER);
	bottomPane.add(status_bar, BorderLayout.SOUTH);

  	this.setBottomComponent(bottomPane);

	set_data_model();
	setMenuProperly();

    }

    // This is just to give a different signature for the 
    // combo box actionPerformed event handler.
    private void actionPerformed1(ActionEvent ae) {
	actionPerformed(ae);
    }

    public void actionPerformed(ActionEvent ae) {
	
	String whatsup = ae.getActionCommand();
	//assemdi_frame.get().setWaitCursor();

	try {

	    if (whatsup.equals("CopyTable")) {
		ExcelAdapter.copy_to_excel( jtable );
		return;
           
	    } else if (whatsup.equals("Print Table")) {

		 Utilities.printTable( getJTable() );

	    } else if (whatsup.equals("Save Table As...")) {
	
                Utilities.save_table(getCurrentTable());
                return;
            } else if (whatsup.equals("CopyKeys")) {
                int row = getJTable().getSelectedRow();
                if (row < 0 && getJTable().getRowCount() > 0) {
                    row = 0;
                    getJTable().getSelectionModel().setSelectionInterval(0,0);                   
                }
                if (row >= 0)
                        ExcelAdapter.copy_keys(row, jadapter);               
                return;
            } else if (whatsup.equals("PasteKeys")) {

//                Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
//                java.awt.datatransfer.Transferable  content = clipboard.getContents(this);
                
//                pasteKeys (content.getTransferData(DataFlavor.stringFlavor).toString());
                pasteKeys(ExcelAdapter.get_keys());
                
	    } else if (whatsup.equals("Copy") ||
            whatsup.equals("Paste") ||
            whatsup.equals("Cut")) {
                Utilities.do_copycutpaste(whatsup);
                
            } else if (whatsup.equals("Run")) {
                
                stopEditing();
                
                if (!promptToOverwrite("Run")) {
                    //assemdi_frame.get().setDefCursor();
                    return;
                }
                execute_command();
                
            } else if (whatsup.compareTo("Stop") ==0) {
                
                if (asse.dbq.cancelJob(jobid)) {
                    setRunMenu(true);
                    flag_executing = false;
                }
                
                return;

	    } else if (whatsup.equals("Delete")) {
		if (jtable.getSelectedRow() < 0) {
		    JOptionPane.showInternalMessageDialog(this,
							  "Select rows to delete first.",
							  "Delete",
							  JOptionPane.INFORMATION_MESSAGE);
		    return;
		}


		stopEditing();
		jadapter.deleteRows(jtable.getSelectedRows());
		jtable.clearSelection();
		jadapter.fireTableDataChanged();
	    } else if (whatsup.equals("Clear Results")) {
		stopEditing();
		if (!promptToOverwrite("Clear Results")) {
		    //assemdi_frame.get().setDefCursor();
		    return;
		}
		jtable.clearSelection();
		jadapter.clearAllRows();
	    } else if (whatsup.equals("Show Deleted")) {
		// 	    AbstractTableModel table = jadapter.get_deleted();
		// 	    DeletedDialog dd = new DeletedDialog(assemdi_frame.get(),
		// 						 "DELETED ROWS",
		// 						 table);
		DeletedDialog dd = new DeletedDialog(assemdi_frame.get(),
						     "DELETED ROWS",
						     jadapter);
	    } else if (whatsup.equals("Show as Plain Text")) {

		ByteArrayOutputStream x = new ByteArrayOutputStream();
		try {
		    PrintTableModel.print(jtable.getModel(), 
					  new PrintStream(x));
		    new ErrDialog(assemdi_frame.get(), 
				  "Plain Text", x.toString(), 
				  "ShowPlainText");
		}
		catch (Exception ex) {
		    new ErrDialog ("Save FAILED",ex);
		}
		
	    } else if (whatsup.equals("Duplicate Rows")) {
		if (jtable.getSelectedRow() < 0) {
		    JOptionPane.showInternalMessageDialog(this,
						  "Select Rows to Duplicate.",
						  "Duplicate Rows",
						  JOptionPane.INFORMATION_MESSAGE);
		    return;
		}
		boolean flag_dup = true;
		jadapter.insertRows(jtable.getSelectedRows(), flag_dup);
		jtable.clearSelection();
	    } else if (whatsup.equals("Undo")) {
		int reset_count = 0;
		if (jtable.getSelectedRow() < 0) {
		    JOptionPane.showInternalMessageDialog(this,
						  "Select Modified Rows to Reset first.",
						  "Undo",
						  JOptionPane.INFORMATION_MESSAGE);
		    return;
		}
		if (jtable.isEditing()) {
		    cancelEditing();
		    reset_count++;
		} 
		reset_count += jadapter.resetRows(jtable.getSelectedRows());
		//jtable.clearSelection();
		if (reset_count == 0) {
		    JOptionPane.showInternalMessageDialog(this,
						  "No Modified Rows found to Reset.",
						  "Reset",
						  JOptionPane.INFORMATION_MESSAGE);
		}
	    } else if (whatsup.equals("Commit")) {
		stopEditing();
		update_status("Executing..");
		jadapter.update();
	    } else if (whatsup.equals("Insert")) {
		if (jtable.getSelectedRow() < 0 &&
		    jtable.getRowCount() > 0) {
		    JOptionPane.showInternalMessageDialog(this,
						  "You need to select a row to indicate insertion point.",
						  "Insert",
						  JOptionPane.INFORMATION_MESSAGE);
		    return;
		}
		
		stopEditing();
		if (jadapter == null)
		    return;
		jadapter.insertRows(jtable.getSelectedRows());

		// 	    jtable.valueChanged(new ListSelectionEvent(this, 0, 0, false));
		jtable.clearSelection();
	    } else {
		stopEditing();
		JOptionPane.showInternalMessageDialog(this,
					      "This event is not programmed yet.",
					      whatsup,
					      JOptionPane.INFORMATION_MESSAGE);
	    }
	} 
	catch (Exception ex) {
	    ex.printStackTrace();
	}
	finally {
	    this.repaint();
	    update_status();
	    //assemdi_frame.get().setDefCursor();
	}
    }

     public void execute_command() {
	
	if (flag_executing)
	    return;

	
        //build SQL statement and retrieve
        StringBuffer where = new StringBuffer();
        String       param_val[];
        String       separator = " where ";
        for (int i = param_panel.get_param_count() - 1; i >=0; i--) {
            param_val = param_panel.get_labelparam(i);
            //System.out.println(param_val[0]);
            String col;
            String val;
            
            col = param_val[0];
            val = param_val[1].trim();
            String op = " = "; {
                if (val.indexOf(">=") == 0) {
                    op = " >= ";
                    val = val.substring(2).trim();
                } else if (val.indexOf(">") == 0) {
                    op = " > ";
                    val = val.substring(1).trim();
                } else if (val.indexOf("<=") == 0) {
                    op = " <= ";
                    val = val.substring(2).trim();
                } else if (val.indexOf("<") == 0) {
                    op = " < ";
                    val = val.substring(1).trim();
                }
            }
            
            if (val.length() > 0) {
                String col_type = table_info.get_columnType(i+1);
                //System.out.println(col_type);
                if (col_type.indexOf("char") >= 0 ||
                col_type.indexOf("date") >= 0 ||
                col_type.indexOf("string") >= 0 ||
                col_type.indexOf("timestamp") >= 0) {
                    where.append(separator);
                    where.append(col);
                    if (val.indexOf("%") >= 0)
                        where.append(" like '");
                    else
                        where.append(op + " '");
                    where.append(val);
                    where.append("'");
                    separator = " and\n";
                } else {
                    where.append(separator);
                    where.append(col);
                    where.append(op);
                    where.append(val);
                    separator = " and\n";
                }
            }
        }
        //System.out.println("where is " + where.toString());
        String sql_stmt;
        if (where.length() > 0)
            sql_stmt = "select * from " + table_name +
            where.toString();
        else {
            sql_stmt = "select * from " + table_name ;
            int retvalue =
            JOptionPane.showInternalConfirmDialog(this,
            "You did not specify any retrieve parameters. Too many rows might be returned. Continue ?",
            "Retrieve",
            JOptionPane.YES_NO_OPTION,
            JOptionPane.WARNING_MESSAGE );
            if (retvalue != JOptionPane.YES_OPTION) {
                //assemdi_frame.get().setDefCursor();
                return;
            }
        }
        
        final String command = sql_stmt;
 
        flag_executing = true;
        setRunMenu(false);
        update_status("Running..");
        
        jobid = asse.dbq.addJob(command, this);
        
        final JTablePane xpane = this;
        
        Runnable dbjob = new Runnable() {
            public void run() {
                jobid = asse.dbq.addJob(command, xpane);
            }
        };
        
        SwingUtilities.invokeLater(dbjob);
     }

    public TableModel getCurrentTable() {
	if (jtable != null && jtable.getModel() != null) 
	    return jtable.getModel();
	else
	    return null;
    }
    public JTableRowHeader getJTable() {
	if (jtable != null && jtable.getModel() != null) 
	    return jtable;
	else
	    return null;
    }

    public void stopEditing() {
	try {
	    if (jtable.isEditing()) {
		jtable.editingStopped(chg_event);
	    }
	}
	catch (Exception ex) {
	}
    }
    
    public void cancelEditing() {
	try {
	    if (jtable.isEditing()) {
		jtable.editingCanceled(chg_event);
	    }
	}
	catch (Exception ex) {
	}
    }

    public String getTableName() {
	if (table_info == null || !table_info.isValid())
	    return "TABLEMODE";
	
	if (table_info.isTableEditable()) 
	    return table_info.getTableName();
	else
	    return table_info.getTableName() + " ** Not Editable ** ";
    }

    public void transferTable(myJDBCAdapter new_table) {
	try {
	    if (new_table == null)
		return;

	    if (table_info == null || !table_info.isValid()) {
		new ErrDialog(assemdi_frame.get(), "Transfer Invalid", "Target Table does not have unique indexes or is invalid..");
		return;
	    }
		
	    if (new_table.matchesTable(table_info)) {

		if (!promptToOverwrite("Transfer"))
		    return;

		change_data_model(new myJDBCAdapter(new_table));
		JOptionPane.showInternalMessageDialog(this,
						      "Transfer successful !");
	    }
	    else
		new ErrDialog(assemdi_frame.get(), "Transfer Failed", "Tables do not match.");
	} catch (Exception ex) {
	    new ErrDialog("Transfer Failed", ex);
	}
    }
    public void update_status(String status) {
	status_bar.setText(status);
    }

    public void update_status() {
	if (statusjob == null)
	    statusjob = new Runnable() {
		    public void run() {
			String stat;
			if (jadapter != null) 
			    stat = jadapter.get_status(jtable.getSelectedRow());
			else
			    stat = "STATUS";
			status_bar.setText(stat);
		    }
		};
	
	SwingUtilities.invokeLater(statusjob);
    }

    private void  pasteKeys (String content) {
        String lines[] = content.split("\n");
        if (lines.length != 2)
            return;
        String cols[] = lines[0].split("\t");
        String vals[] = lines[1].split("\t");
        if (cols.length != vals.length)
            return;
        
        for (int i = 0; i < param_panel.get_param_count(); i++) {
            param_panel.set_param(i, "");
        }
        
        Vector key_names = new Vector();
        String indexes[] = table_info.get_uniqueIndexes();
        for (int i1 = 0; i1 < indexes.length; i1++) {
            String idx_cols[] = table_info.get_indexKeys(indexes[i1]);
            for (int i2 = 0; i2 < idx_cols.length; i2++)
                key_names.add(idx_cols[i2]);
        }
        for (int j = 0 ;j < param_panel.get_param_count() && j < cols.length; j++)
            if (key_names.contains(cols[j]))
                param_panel.set_param(cols[j], vals[j]);
   
    }

    private void set_data_model() {
	
	Vector vcol_names = new Vector();
	Vector vcol_types = new Vector();
	Vector vdata = new Vector();
	for (int i = 0; i < table_info.get_columnCount();  i++) {
	    vcol_names.add(table_info.get_columnName(i+1));
	    vcol_types.add(table_info.get_columnType(i+1));
	}
	ezTable ezt = new ezTable(vdata, vcol_names, vcol_types);
	change_data_model(new myJDBCAdapter(ezt));
    }

    private void change_data_model(myJDBCAdapter j) {
	jadapter = j;
	jadapter.setTableInfo( table_info );

	jtable.setModel(jadapter);

	jtable.setSmartEditors(table_info);
	jtable.getModel().addTableModelListener( 
						new TableModelListener() {
							public void tableChanged(TableModelEvent e) {
							    update_status();
							} }
						);
    }

    
    private void setMenuProperly() {
	
  	boolean editable = table_info.isTableEditable();
        Boolean  editable_b = editable ? Boolean.TRUE : Boolean.FALSE;
        
  	jtf.setMenuItem("Insert", editable_b);
  	bp.setEnabled("Insert", editable);
  	jtf.setMenuItem("Delete", editable_b);
  	bp.setEnabled("Delete", editable);
  	jtf.setMenuItem("Show Deleted", editable_b);
  	bp.setEnabled("Show Deleted", editable);
  	jtf.setMenuItem("Reset", editable_b);
  	bp.setEnabled("Reset", editable);
  	jtf.setMenuItem("Duplicate Rows", editable_b);
  	bp.setEnabled("Duplicate Rows", editable);
  	jtf.setMenuItem("Commit", editable_b);
  	bp.setEnabled("Commit", editable);
        
        jtf.refreshMenu();
        
    }

    
    private boolean promptToOverwrite(String title) {
  	if (jadapter == null || !jadapter.isModified())
  	    return true;

	return 
	    (JOptionPane.YES_OPTION == 
	     JOptionPane.showInternalConfirmDialog(this,
						   "TableMode result is modified. Overwrite ?",
						   "Warning",
						   JOptionPane.YES_NO_OPTION) );
    }

    public void processResult ( final DBQResult dbqr ) {

	Runnable dbjob = new Runnable() {
		public void run() {
		    if (dbqr.ezt_array != null &&
			dbqr.ezt_array.length > 0) {
			jadapter.setAllData( dbqr.ezt_array[0] ); 
			repaint();
		    }
	
                    if (dbqr.sqle != null)
                        new ErrDialog("DATABASE ERROR",dbqr.sqle);
                    
                    setRunMenu(true);
                    flag_executing = false;
                }
        };

	SwingUtilities.invokeLater(dbjob);

    }
    
    private void setRunMenu (boolean value) {
        bp.setEnabled("Run", value);
        bp.setEnabled("Stop",  value ? false : true);
        jtf.setMenuItem("Run", new Boolean(value));
        jtf.setMenuItem("Stop", new Boolean(value ? false : true));
        jtf.refreshMenu();
    }
}
