package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class JlistParams extends JPanel  {

    static int MAX_PARAMS = 15;
    HashSet jtf_set = new HashSet();
    HashSet jla_set = new HashSet();
    HashSet jtfp_set = new HashSet();

    Vector jtf = new Vector();
    Vector jla = new Vector();

    int   param_count = 0;
    GridBagLayout  gb = new GridBagLayout();
    GridBagConstraints gc = new GridBagConstraints();


    public JlistParams (String str) {

	super();
	this.add(new FancyPanel(str));
	this.setLayout(gb);
    }
    public JlistParams (Param [] plist) {

	super();
	add_params(plist);
	this.setLayout(gb);
    }

    public  int get_param_count () {
	return param_count;
    }
    
    public  String [] get_labelparam (int i) {
	String [] rte = new String[2];
	rte[0] = ((JLabel)jla.elementAt(i)).getText();
	rte[1] = ((JTextField)jtf.elementAt(i)).getText();
	return rte;
    }
    public  String get_param (String label) {

	for (int i = 0; i < jla.size(); i++) {
	    if (label.compareTo( ((JLabel)jla.elementAt(i)).getText() ) ==0)
		return ((JTextField)jtf.elementAt(i)).getText();
	}
	 
	return null;
    }

    public  String set_param (String label, String value) {

	for (int i = 0; i < jla.size(); i++) {
	    if (label.compareTo( ((JLabel)jla.elementAt(i)).getText() ) ==0) {
		((JTextField)jtf.elementAt(i)).setText(value);
		return value;
	    }
	    
	}
	return null;
    }

    public  String set_param (int idx, String value) {
        String prev_value = "";
        if (idx < jtf.size()) {
            prev_value = ((JTextField)jtf.elementAt(idx)).getText();
            ((JTextField)jtf.elementAt(idx)).setText(value);
        }
        return prev_value;
            
    }
    public void add_params (Param [] plist) {


	JLabel jlax;
	JTextField jtfx;

	this.removeAll();
	jla.clear();
	jtf.clear();

	param_count = plist.length;
	int  field_count = jtf_set.size();
	int  label_count = jla_set.size();
	int  fieldp_count = jtfp_set.size();

	Iterator i_field = jtf_set.iterator();
	Iterator i_label = jla_set.iterator();
	Iterator i_fieldp = jtfp_set.iterator();

// 	System.out.println ("starting " +
// 			    " jla : " + jla_set.size() +
// 			    " jtf :" + jtf_set.size() +
// 			    " jtfp :" + jtfp_set.size() 
// 			    );
			    
	for (int i = 0;i < param_count ; i++) {

	    if (plist[i] == null)
		break;
	    
	    gc.anchor = GridBagConstraints.WEST;
	    gc.gridx = 0;
	    gc.gridy = i;
	    gc.gridheight = 1;
	    gc.gridwidth  = 1;
	    gc.weightx = 0;
	    gc.weighty = 1;
	    gc.fill  = GridBagConstraints.NONE;

	    if (i < label_count) { 
		jlax = (JLabel)i_label.next();
		jlax.setText(plist[i].get_name());
	    } else {
		jlax = new JLabel(plist[i].get_name());
		jla_set.add(jlax);
	    }
	    jla.add(jlax);
	    gb.setConstraints( jlax, gc);
	    add( jlax );

	    gc.gridx = GridBagConstraints.RELATIVE;
	    gc.gridheight = 1;
	    gc.gridwidth  = 2;
	    gc.weightx = 1;
	    gc.weighty = 1;
	    gc.fill  = GridBagConstraints.HORIZONTAL;

	    if (plist[i].is_password()) 
		if (i < fieldp_count) 
		    jtfx = (JPasswordField)i_fieldp.next();
		else {
		    jtfx =  new JPasswordField(plist[i].get_def(), 10);
		    jtfp_set.add(jtfx);
		}
	    else
		if (i < field_count)
		    jtfx = (JTextField)i_field.next();
		else {
		    jtfx =  new JTextField(plist[i].get_def(), 10);
		    jtf_set.add(jtfx);
		}
	    jtfx.setText(plist[i].get_def());
	    jtf.add(jtfx);
	    gb.setConstraints( jtfx, gc);
	    add( jtfx );

   	}
// 	System.out.println ("ending " +
// 			    " jla : " + jla_set.size() +
// 			    " jtf :" + jtf_set.size() +
// 			    " jtfp :" + jtfp_set.size() 
// 			    );

	this.validate();
    }	

    public JTextField get_text_field (int index) {
	return (JTextField)jtf.elementAt(index);
    }
}



