package net.sourceforge.asse;

import java.io.*;

class LocateCommand {

    static int debug = 0;
    public static void main (String args[]) {
	
	try {
	    FileReader in = new FileReader(args[0]);
	    int bufsize = 100000;
	    char buf[] = new char[bufsize];
	    if (in.read(buf) == bufsize) {
		System.out.println("Debug buffer full at " + bufsize);
		System.exit (1);
	    }
	    in.close();
	    debug = 1;

	    String cmd = LocateCommand.find(new String(buf), 
					Integer.parseInt(args[1]));
	    System.out.println(cmd);

	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }

    static String find (String sqltext, int position) {
	
	int go_line = 0;
	int total_read = 0;
	boolean  started = false;
	String line;
	StringBuffer cmd = new StringBuffer();
	StringBuffer pcmd = cmd;
	int   line_count = 0;

	try {
	    BufferedReader br = new BufferedReader( new StringReader(sqltext));
	    while ((line = br.readLine()) != null) {
		total_read += line.length() + 1;
		line_count += 1;
		if (total_read > position) 
		    started = true;

		line = line.trim();
		if (line.length() > 0 && 
		    !(line.length() >= 2 &&
		      line.substring(0,2).compareTo("--") == 0)) {
		    if (line.compareTo("go") ==0) {
			go_line = line_count;
			if (started)
			    break;
			pcmd = cmd;
			cmd = new StringBuffer();		    
		    } else if (line.length() > 0 && 
			       line.substring(line.length() - 1).compareTo(";") == 0) {
			cmd.append("\n");
			cmd.append(line.substring(0, line.length() - 1));
			go_line = line_count;
			if (started)
			    break;
			pcmd = cmd;
			cmd = new StringBuffer();		    
                    } else
			cmd.append("\n" + line);
		}
	    }
	    
	    br.close();

	    if (cmd != null && cmd.length() == 0 && 
		pcmd != null && pcmd.length() > 0) 
		cmd = pcmd;
	    
	    if (debug > 0) {
		System.out.println("DEBUG:last go position is " + go_line);
		System.out.println("DEBUG:total read " + total_read);
	    }
	    return cmd.toString();
	} 
	catch (IOException ex) {
	    ex.printStackTrace();
	}
	
	return "";
    }
}
