/*
 * LoginDialog.java
 *
 * Created on November 21, 2004, 5:28 AM
 */

package net.sourceforge.asse;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
/**
 *
 * @author  Manish Shah
 */
public class LoginDialog extends javax.swing.JDialog {
    
    /** Creates new form LoginDialog */
    public LoginDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        dbprofiles = AsseGlobal.dbprofiles;
        if ( asse.dbexecq != null) {
            setTitle("Connected");
            cb_login.setText("Disconnect");
        }
        
        
        Vector sl = getSortedProfileList();
        for (int i = 0; i < sl.size(); i++)
            cbb_profiles.addItem(sl.elementAt(i));
        
        cbb_servers.addItem("NONE");
        String servers[] = ServerDefaults.getServerNames();
        for (int i = 0; i < servers.length; i++)
            cbb_servers.addItem(servers[i]);
        
        if (cbb_servers.getItemCount() == 1)
            cbb_servers.setEnabled(false);
        
        setLocationRelativeTo(parent);
        
        
        this.addWindowListener(new WindowAdapter() {
            public void windowActivated(WindowEvent evt) {
                
                String lastprofile = DwbjProps.getProperty("last_profile");
                if (lastprofile != null)
                    cbb_profiles.setSelectedItem(lastprofile);
                cbb_profiles.requestFocus();
                //focusOnButton();//okbutton.requestFocus();
                
            }
            
            //		private void focusOnButton() {
            //		    Runnable doit = new Runnable() {
            //			    public void run() {
            //				cb_login.requestFocus();
            //			    }
            //			};
            //
            //		    try {
            //			SwingUtilities.invokeLater(doit);
            //		    }
            //		    catch (Exception ex) {
            //			ex.printStackTrace();
            //		    }
            //		}
        });
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        cbb_profiles = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        cbb_servers = new javax.swing.JComboBox();
        jtf_host = new javax.swing.JTextField();
        jl_host = new javax.swing.JLabel();
        jl_port = new javax.swing.JLabel();
        jtf_port = new javax.swing.JTextField();
        jl_loginid = new javax.swing.JLabel();
        jtf_loginid = new javax.swing.JTextField();
        jl_password = new javax.swing.JLabel();
        jtf_password = new javax.swing.JPasswordField();
        cb_login = new javax.swing.JButton();
        cb_cancel = new javax.swing.JButton();
        cb_remove = new javax.swing.JButton();
        jchk_savepass = new javax.swing.JCheckBox();
        jl_dbname = new javax.swing.JLabel();
        jtf_dbname = new javax.swing.JTextField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Connect to Database");
        jLabel1.setText("DBProfiles");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jLabel1, gridBagConstraints);

        cbb_profiles.setEditable(true);
        cbb_profiles.setMinimumSize(new java.awt.Dimension(100, 19));
        cbb_profiles.setPreferredSize(new java.awt.Dimension(200, 19));
        cbb_profiles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbb_profilesActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cbb_profiles, gridBagConstraints);

        jLabel2.setText("Servers");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jLabel2, gridBagConstraints);

        cbb_servers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbb_serversActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cbb_servers, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jtf_host, gridBagConstraints);

        jl_host.setText("Hostname or IP");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jl_host, gridBagConstraints);

        jl_port.setText("Port");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jl_port, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jtf_port, gridBagConstraints);

        jl_loginid.setText("LoginID");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jl_loginid, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jtf_loginid, gridBagConstraints);

        jl_password.setText("Password");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jl_password, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jtf_password, gridBagConstraints);

        cb_login.setText("Connect");
        cb_login.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cb_loginActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cb_login, gridBagConstraints);

        cb_cancel.setText("Cancel");
        cb_cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cb_cancelActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cb_cancel, gridBagConstraints);

        cb_remove.setText("RemoveProfile");
        cb_remove.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cb_removeActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(cb_remove, gridBagConstraints);

        jchk_savepass.setText("Save Password ? (unsafe)");
        jchk_savepass.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        getContentPane().add(jchk_savepass, gridBagConstraints);

        jl_dbname.setText("Database");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jl_dbname, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jtf_dbname, gridBagConstraints);

        pack();
    }//GEN-END:initComponents
    
    private void cbb_serversActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbb_serversActionPerformed
        // TODO add your handling code here:
        Object obj1 = cbb_servers.getSelectedItem();
        String servname = "";
        if (obj1 != null)
            servname = obj1.toString();
        
        if (!(servname.equals("NONE") || servname.equals("")) ) {
            jtf_host.setText(ServerDefaults.getAttrib(servname,"host"));
            jtf_port.setText(ServerDefaults.getAttrib(servname, "port"));
            jtf_host.setEnabled(false);
            jtf_port.setEnabled(false);
        } else {
            jtf_host.setEnabled(true);
            jtf_port.setEnabled(true);
        }
    }//GEN-LAST:event_cbb_serversActionPerformed
    
    private void cb_removeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cb_removeActionPerformed
        // TODO add your handling code here:
        Object o1 = cbb_profiles.getSelectedItem();
        if (o1 == null)
            return;
        String profname = o1.toString();
        dbprofiles.remove(profname);
        cbb_profiles.removeItem(o1);
        cbb_profiles.setSelectedIndex(1);
        
    }//GEN-LAST:event_cb_removeActionPerformed
    
    private void cb_cancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cb_cancelActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_cb_cancelActionPerformed
    
    private void cb_loginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cb_loginActionPerformed
        // TODO add your handling code here:
        
        String whatsup = evt.getActionCommand();
        if (whatsup.compareTo("Connect") == 0) {
            connect_to_db();
        }
        if (whatsup.compareTo("Disconnect") == 0) {
            disconnect_to_db();
        }
    }//GEN-LAST:event_cb_loginActionPerformed
    
    private void cbb_profilesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbb_profilesActionPerformed
        // TODO add your handling code here:
        //cbb_servers.setSelectedItem("NONE");
        String prof_name = cbb_profiles.getSelectedItem().toString();
        Object o1 = dbprofiles.get(prof_name);
        if (o1 != null) {
            DBProfile dbp = (DBProfile)dbprofiles.get(prof_name);
            String dbp_server = dbp.getServer();
            if (dbp_server.length() > 0) {
                cbb_servers.setSelectedItem(dbp_server);
                if (cbb_servers.getSelectedItem() == null ||
                cbb_servers.getSelectedItem().toString().equals("NONE") ||
                !cbb_servers.getSelectedItem().toString().equals(dbp_server)) {
                    cbb_servers.setSelectedItem("NONE");
                    jtf_host.setText(dbp.getHost());
                    jtf_port.setText(dbp.getPort());
                    jtf_host.setEnabled(true);
                    jtf_port.setEnabled(true);
                } else {
                    jtf_host.setEnabled(false);
                    jtf_port.setEnabled(false);
                }
            } else {
                cbb_servers.setSelectedItem("NONE");
                jtf_host.setText(dbp.getHost());
                jtf_port.setText(dbp.getPort());
                jtf_host.setEnabled(true);
                jtf_port.setEnabled(true);
            }
            //            System.out.println("Setting host to :" + dbp.getHost());
            
            jtf_loginid.setText(dbp.getLogin());
            jtf_password.setText(dbp.getPassword());
            jtf_dbname.setText(dbp.getDBname());
            if (dbp.getPassword().length() > 0)
                jchk_savepass.setSelected(true);
            getRootPane().setDefaultButton(cb_login);
        }
        
    }//GEN-LAST:event_cbb_profilesActionPerformed

/**
 * @param args the command line arguments
 */
public static void main(String args[]) {
    new LoginDialog(new javax.swing.JFrame(), true).show();
}

private void disconnect_to_db() {
    
    if (asse.dbexecq != null) {
        asse.dbexecq.close();
        asse.dbexecq = null;
        asse.dbh     = null;
        asse.dbq     = null;
    }
    cb_login.setText("Connect");
    setTitle("Login");
}

private void connect_to_db() {
    
    if (cbb_profiles.getSelectedItem() == null ||
    cbb_profiles.getSelectedItem().toString().equals("NEW PROFILE")) {
        setTitle("PROFILE name required");
        return;
    }
    
    setCursor(new Cursor(Cursor.WAIT_CURSOR));
    
    DBMulti  dbh = new DBMulti(
    jtf_host.getText(),
    jtf_port.getText(),
    jtf_loginid.getText(),
    new String(jtf_password.getPassword()),
    "", //proxy
    "AniSa"
    );
    
    if (dbh.get_connection() == null) {
        setTitle("Login failed. #" +  ++fail_count);
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return;
    }
    
    
    assemdi_frame.get().setTitle(cbb_profiles.getSelectedItem().toString());
    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    disconnect_to_db();
    
    asse.dbh = dbh;
    asse.dbh.set_debug(true);
    asse.dbq = new DBQueue(dbh);
    asse.dbexecq = new DBExecutor(
    asse.dbq,
    asse.dbh,
    new asse_DBML()
    );
    
    asse.dbexecq.start();
    try {
        asse.dbq.executeQuery("use "+ jtf_dbname.getText());
    } catch (Exception ex) {
        jtf_dbname.setText("");
    }
    
    Object oserv = cbb_servers.getSelectedItem();
    
    DBProfile good = new DBProfile(
    cbb_profiles.getSelectedItem().toString(),
    jtf_loginid.getText(),
    jchk_savepass.isSelected() ?
    new String(jtf_password.getPassword()) : "",
    oserv != null ? oserv.toString() : "",
    jtf_host.getText(),
    jtf_port.getText(),
    jtf_dbname.getText());
    
    dbprofiles.put(good.getName(), good);
    DwbjProps.setProperty("last_profile", good.getName());
    //        System.out.println("Setting host to :" + good.getHost());
    
    
    this.setVisible(false);
    this.dispose();
    
}

private Vector getSortedProfileList() {
    
    Vector v1 = new Vector();
    v1.add("NEW PROFILE");
    
    for (Enumeration e = dbprofiles.keys() ; e.hasMoreElements() ;) {
        v1.add(e.nextElement());
    }
    
    Collections.sort( v1, new Comparator() {
        public int compare(Object o1, Object o2) {
            String s1 = (String) o1;
            String s2 = (String) o2;
            return s1.compareTo(s2);
        }
        public boolean equals(Object o1, Object o2) {
            String s1 = (String) o1;
            String s2 = (String) o2;
            return (s1.compareTo(s2) == 0);
        }
    });
    return v1;
}

Hashtable   dbprofiles;
private int fail_count = 0;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cb_cancel;
    private javax.swing.JButton cb_login;
    private javax.swing.JButton cb_remove;
    private javax.swing.JComboBox cbb_profiles;
    private javax.swing.JComboBox cbb_servers;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JCheckBox jchk_savepass;
    private javax.swing.JLabel jl_dbname;
    private javax.swing.JLabel jl_host;
    private javax.swing.JLabel jl_loginid;
    private javax.swing.JLabel jl_password;
    private javax.swing.JLabel jl_port;
    private javax.swing.JTextField jtf_dbname;
    private javax.swing.JTextField jtf_host;
    private javax.swing.JTextField jtf_loginid;
    private javax.swing.JPasswordField jtf_password;
    private javax.swing.JTextField jtf_port;
    // End of variables declaration//GEN-END:variables
    
}
