package net.sourceforge.asse;
import java.io.*;
import java.util.*;

class Param {
    String name;
    String def; 
    boolean password = false;
    int param_type;

    public static int STR = 0;
    public static int INT = 1;
    public static int FLT = 2;
    public static int DATE = 3;


    public Param (String pname) {
	this(pname, "");
    }

    public Param (String pname, String pdef ) {
	this ( pname, pdef, false);
    }


    public Param (String pname, String pdef, boolean is_password ) {

	this (pname, pdef, is_password, Param.INT);
    }
    public Param (String pname, String pdef, boolean is_password,  int ptype) {

	name = pname;
	def  = pdef;
	password = is_password;
	param_type = ptype;
    }


    public boolean is_password() {
	return password;
    }
    public String get_name() {
 	return name;
    }

    public String get_def() {
  	return def;
    }
    public int get_type() {
  	return param_type;
    }
    public String toString () {
  	StringBuffer str = new StringBuffer("PARAM:Name:" + 
					    get_name());
	if (get_def().length() > 0)
	    str.append(", Default=" + get_def());

	switch (get_type()) {
	  case 1:
	    str.append(", Type = INT");
	    break;
	  case 2:
	    str.append(", Type = FLT");
	    break;
	  case 0:
	    str.append(", Type = STR");
	    break;
	  case 3:
	    str.append(", Type = DATE");
	    break;
	  default: 
	    str.append(", Type = Unknown");
	    break;
	}
	
	return str.toString();
    }
}
