package net.sourceforge.asse;

import java.io.*;
import java.util.*;

//  The following class provides you to store multiple elements by a key
//  and retrieve these via Enumeration interface.
//  Most importantly it can serialize or restore from a file.

class PersistentStore implements Serializable  {

    private Hashtable _hasht;

    public PersistentStore () {
	_hasht = new Hashtable();
    }

    public void put(String key, Object value) {
	_hasht.put(key, value);
    }
    public Object get(String key) {
	return _hasht.get(key);
    }

    public void  remove(String key) {
	_hasht.remove(key);
    }

     public void save(String filename) throws java.io.IOException {
	FileOutputStream ostream = new FileOutputStream(filename);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

	p.writeObject(_hasht);
	p.flush();
	ostream.close();
    }

    public void load(String filename)  
	throws java.io.IOException, 
	       java.lang.ClassNotFoundException {
	
	try {
	    FileInputStream istream = new FileInputStream(filename);
	    ObjectInputStream p = new ObjectInputStream(istream);
	    
	    Object n = p.readObject();
	    if (n instanceof Hashtable) 
		_hasht = (Hashtable) n;
	    
	    p.close();
	} catch (Exception ex) {
	    if (ex instanceof FileNotFoundException)
		System.out.println(filename + " not found, can't load.");
	    else
		ex.printStackTrace();
	}

	if (_hasht == null) 
	    _hasht = new Hashtable();
    
    }
	
    public static void main(String arg[]) {

	PersistentStore x = new PersistentStore();
	try {

	    if (arg.length < 2) {
		x.load("PersistentStore.dat");

		for (Enumeration e = x._hasht.keys(); e.hasMoreElements();
		     ) {
		    Object key = e.nextElement();
		    Object value = x._hasht.get(key);
		    
		    System.out.println("key " + key.toString());
		    System.out.println("value " + value.toString());
		}

	    } else if (arg.length >= 2) {

		for (int i = 0; i < arg.length; i++) {
		    Integer inx = new Integer(i);
		    x.put(inx.toString(), arg[i]);
		}
		x.save("PersistentStore.dat");
	    }
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
	
}
