package net.sourceforge.asse;
import javax.swing.*;
import java.io.*;

public class PickFile {
    
    public static File promptForTableSave(String title) {
	
	JFileChooser fc;
	String lastdir = DwbjProps.getProperty("LastUsedDir", "");
	
	if (lastdir.length() > 0) 
	    fc = new JFileChooser(lastdir);
	else
	    fc = new JFileChooser();
	
	fc.setDialogTitle(title);
	fc.setApproveButtonText(title);
	fc.addChoosableFileFilter(new TabFileFilter());
            
	int returnVal = fc.showOpenDialog(assemdi_frame.get()); 
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    lastdir = fc.getSelectedFile().getParent();
	    DwbjProps.setProperty("LastUsedDir",lastdir);
            if (fc.getSelectedFile().exists())
                return fc.getSelectedFile();
            else {
                String f_name = fc.getSelectedFile().getName();
                if (f_name.matches(".*\\.\\w+$"))
                    return fc.getSelectedFile();
                File x = new File(
                fc.getSelectedFile().getParent()
                + File.separator
                + fc.getSelectedFile().getName() + ".txt");
                return x;
            }
        }
        return null;
	
    }
        
    public static File promptForSQLFile(String title) {
	
	JFileChooser fc;
	String lastdir = DwbjProps.getProperty("LastUsedDir", "");
	
	if (lastdir.length() > 0) 
	    fc = new JFileChooser(lastdir);
	else
	    fc = new JFileChooser();

	fc.setDialogTitle(title);
	fc.setApproveButtonText(title);
        fc.setAcceptAllFileFilterUsed(false);
        fc.addChoosableFileFilter(new SqlFileFilter());


	int returnVal = fc.showOpenDialog(assemdi_frame.get()); 
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    DwbjProps.setProperty("LastUsedDir", 
				  fc.getSelectedFile().getParent());
            if (fc.getSelectedFile().exists())
                return fc.getSelectedFile();
            else {
                String f_name = fc.getSelectedFile().getName();
                if (f_name.matches(".*\\.\\w+$"))
                    return fc.getSelectedFile();
                File x = new File( 
                            fc.getSelectedFile().getParent() 
                            + File.separator
                            + fc.getSelectedFile().getName() + ".sql");
                return x;
            }
	} else 
	    return null;
	
    }

    public static File promptForXMLFile(String title) {
	
	JFileChooser fc;
	String lastdir = DwbjProps.getProperty("LastUsedDir", "");
	
	if (lastdir.length() > 0) 
	    fc = new JFileChooser(lastdir);
	else
	    fc = new JFileChooser();

	fc.setDialogTitle(title);
	fc.setApproveButtonText(title);
	fc.addChoosableFileFilter(new XmlFileFilter());

	int returnVal = fc.showOpenDialog(assemdi_frame.get()); 
	if(returnVal == JFileChooser.APPROVE_OPTION) {
	    DwbjProps.setProperty("LastUsedDir", 
				  fc.getSelectedFile().getParent());
            if (fc.getSelectedFile().exists())
                return fc.getSelectedFile();
	} 
	return null;
	
    }
}
