
package net.sourceforge.asse;


import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import java.io.File;

import java.util.*;


class ReadReportXml 
{

    public static void main(String[] args) {
	try {
	    getReports(new File(args[0]));
	    
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
    

    static AReport[] getReports( File xmlfile ) throws org.jdom.JDOMException {


	SAXBuilder   builder = new SAXBuilder();
	org.jdom.Document doc = builder.build(xmlfile);

	Vector rpt_list = new Vector();
	
	Element root = doc.getRootElement();
	
	java.util.List rpt_elements = root.getChildren("report");
	
	Iterator rpt_itr = rpt_elements.iterator();
	while (rpt_itr.hasNext()) {

	    AReport rpt;

	    Element elem = (Element) rpt_itr.next();
	    if (elem != null) {
		rpt = new AReport( elem.getChild("name").getTextTrim(), 
				   elem.getChild("desc").getTextTrim() );
		
		List alist = elem.getChildren("sql");
		for (int i = 0; i < alist.size(); i++) 
		    rpt.addSql( ((Element)alist.get(i)).getTextTrim() );
		    
		alist = elem.getChildren("param");
		for (int i = 0; i < alist.size(); i++) {
		    Element e = (Element)alist.get(i);
		    String name = e.getChild("name").getTextTrim();
		    String def  = e.getChild("default").getTextTrim();

		    
		    if (name != null) 
			if (def != null)  
			    rpt.addParam(new Param( name, def ) );
			else
			    rpt.addParam(new Param( name ) );
		}
		
		alist = elem.getChildren("column");
		for (int i = 0; i < alist.size(); i++) {
		    Element e = (Element)alist.get(i);
		    String colname     = e.getChild("name").getTextTrim();
                    String format_str  = e.getChild("format") == null ? null : e.getChild("format").getTextTrim();
                    String format_class = e.getChild("class") == null ? null : e.getChild("class").getTextTrim();
                    String result_name = e.getChild("result_name") == null ? null : e.getChild("result_name").getTextTrim();
                    
                    
                    if (format_str != null)
                       rpt.setFormat(colname, format_str);
                    
                    if (format_class != null) 
                        rpt.setFormatType(colname, format_class);
                    
                    if (result_name != null)
                        rpt.setTableName(colname, result_name);

		}

		//System.out.println( rpt.toString() );
		rpt_list.add(rpt);
		
	    }

	    
	}

	AReport[]  x = new AReport [5];
	
	return (AReport[] )(rpt_list.toArray(x));
	
	
    }

}
