package net.sourceforge.asse;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

class RecentAccess  
    extends javax.swing.JDialog
    implements ActionListener {

	
    public RecentAccess (JFrame frame, 
			 ActionListener al, 
			 Vector files, 
			 Vector tables,
			 Vector reports)  {

	super (frame, "Recent Accesses", true);

	postTo = al;
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);

	getContentPane().setLayout(new BorderLayout());

	tpane = new JTabbedPane();

	for (int i = 0; i < files.size(); i++) {
	    java.io.File f = new java.io.File (files.elementAt(i).toString() );
	    if (!f.exists()) {
		//System.out.println("Removing .." + f.getName());
		files.remove(i);
		i--;
	    }
	}

	for (int i = 0; i < reports.size(); i++) {
	    java.io.File f = new java.io.File (reports.elementAt(i).toString() );
	    if (!f.exists()) {
		//System.out.println("Removing .." + f.getName());
		reports.remove(i);
		i--;
	    }
	}
	
	recentfiles = new JList(files);
	recenttables = new JList(tables);
	recentreports = new JList(reports);

        recentfiles. addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent me) {
                    if (me.getClickCount() == 2) {
                        actionPerformed(new ActionEvent(this,
                        ActionEvent.ACTION_PERFORMED,
                        "OK"));
                        me.consume();
                    }   
            }
        });
        recenttables. addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent me) {
                if (me.getClickCount() == 2) {
                        actionPerformed(new ActionEvent(this,
                        ActionEvent.ACTION_PERFORMED,
                        "OK"));
                        me.consume();
                }   
            }
        });
        recentreports. addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent me) {
                    if (me.getClickCount() == 2) {
                        actionPerformed(new ActionEvent(this,
                        ActionEvent.ACTION_PERFORMED,
                        "OK"));
                        me.consume();
                    }   
            }
        });
        
	tpane.add("Files", new JScrollPane(recentfiles));
	tpane.add("Tables", new JScrollPane(recenttables));
	tpane.add("Reports", new JScrollPane(recentreports));

	getContentPane().add(tpane, BorderLayout.CENTER);

	cb_ok = new JButton("OK");
	cb_ok.addActionListener(this);	

	getContentPane().add(cb_ok, BorderLayout.SOUTH);

	setSize(DwbjProps.getIntProperty("RecentAccesswidth", 185),
		DwbjProps.getIntProperty("RecentAccessheight", 210));
    
	setLocationRelativeTo(frame);

	getRootPane().setDefaultButton(cb_ok);
        tpane.setSelectedIndex(DwbjProps.getIntProperty("RecentTab",0));
	this.show();	

    }
  
    public void actionPerformed (ActionEvent ae) {

	String whatsup = ae.getActionCommand();
        ActionEvent post = null;
	if (whatsup.compareTo("OK") == 0) {
	    
	    String title = tpane.getTitleAt(tpane.getSelectedIndex());
	    
	    
	    if (title.compareTo("Files") == 0) {
		java.io.File sqlfile = (java.io.File) recentfiles.getSelectedValue();
		if (sqlfile != null)
		    post = new ActionEvent(postTo, 
					   ActionEvent.ACTION_PERFORMED,
					   sqlfile.getAbsolutePath() + ":Open File:");
//		else
//		    post = new ActionEvent(postTo, 
//					   ActionEvent.ACTION_PERFORMED,
//					   "none");
	    } else if (title.compareTo("Tables") == 0) {
		String tablename = (String) recenttables.getSelectedValue();
		if (tablename != null)
		    post = new ActionEvent(postTo, 
					   ActionEvent.ACTION_PERFORMED,
					   tablename + ":Open Table:");
//		else
//		    post = new ActionEvent(postTo, 
//					   ActionEvent.ACTION_PERFORMED,
//					   "none");
	    } else if (title.compareTo("Reports") == 0) {
		java.io.File xmlfile = (java.io.File) recentreports.getSelectedValue();
		if (xmlfile != null)
		    post = new ActionEvent(postTo, 
					   ActionEvent.ACTION_PERFORMED,
					   xmlfile.getAbsolutePath() + ":Open Report:");
//		else
//		    post = new ActionEvent(postTo, 
//					   ActionEvent.ACTION_PERFORMED,
//					   "none");
	    }
//	    else
//		post = new ActionEvent(postTo, 
//				       ActionEvent.ACTION_PERFORMED,
//				       "none");
	    
            if (post != null && post.paramString().compareTo("none") != 0) {
                final ActionEvent post_final = post;
		Runnable job = new Runnable () {
			public void run() {
			    postTo.actionPerformed(post_final);
			}
		    };
		
		SwingUtilities.invokeLater(job);
	    }
            DwbjProps.setIntProperty("RecentTab",tpane.getSelectedIndex());
	    this.setVisible(false);
	    this.dispose();
	}

    }

    JButton               cb_ok;
    JTabbedPane           tpane;
    JList                 recentfiles;
    JList                 recenttables;
    JList                 recentreports;
    ActionListener        postTo;
    
}




