package net.sourceforge.asse;
import java.awt.*;
import java.math.*;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.text.*;
import java.util.*;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.*;

public class ReportPanel extends JSplitPane
implements ActionListener, DBResultListener  {
    
    AReport[]           rpts;
    JSplitPane          toppane;
    JPanel              rpt_select_pane, bottom_pane;
    JTextArea           desc_area;
    JComboBox           rpt_list;

    TabbedTablePane       tabbedpane;
    JTableRowHeader       jtable;
    JlistParams           param_panel;
    
    JButtonPanel          bp;
    Integer               jobid;
    boolean               flag_executing = false;
    
    JLabel                status_bar;
    Runnable              statusjob;
    
    JEditorPane           rpt_desc;
    ReportFrame           jtf;
    
    GridBagLayout  gb = new GridBagLayout();
    GridBagConstraints gc = new GridBagConstraints();
    
    public ReportPanel(ReportFrame rf, AReport[] prpts) {
        
  
        super(JSplitPane.VERTICAL_SPLIT, true);
        jtf = rf;
        try {
            
             
            rpts = prpts;
            AReport first_rpt = rpts[0];
            
        
            rpt_list = new JComboBox();
            for (int i = 0; i < rpts.length && rpts[i] != null; i++) {
                //System.out.println( rpts[i].toString());
                //System.out.println( rpts[i].getName());
                rpt_list.addItem(rpts[i].getName());
            }
            rpt_list.addActionListener(
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    selectReport();
                }
            });
            
            rpt_desc = new JEditorPane("text/plain", first_rpt.getDesc());
            rpt_desc.setBackground(this.getBackground());
            JScrollPane jp = new JScrollPane(rpt_desc);
            jp.setPreferredSize(new java.awt.Dimension(500, 100));
            jp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            
            GridBagLayout gridbag = new GridBagLayout();
            GridBagConstraints c = new GridBagConstraints();
         
            rpt_select_pane = new JPanel();
            rpt_select_pane.setLayout(gridbag);
            
            c.gridx = 0; 
            c.gridy = 0;
            c.weightx = 1;
            c.weighty = 0;
            c.fill = GridBagConstraints.HORIZONTAL;
            
            
            rpt_select_pane.add( rpt_list, c);
            
            c.gridx = 0;
            c.gridy = 1;
            c.weighty = 1;
            c.fill = GridBagConstraints.BOTH;
            
            rpt_select_pane.add(jp, c);
            
//            rpt_select_pane.add( jp );
            
            
            param_panel = new JlistParams(first_rpt.getParams());
            jp = new JScrollPane(param_panel);
            jp.setPreferredSize(new Dimension(500,100));
            jp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
            
     
            toppane = new JSplitPane(JSplitPane.VERTICAL_SPLIT, true);
            toppane.setTopComponent(rpt_select_pane);
            toppane.setBottomComponent(jp);

            tabbedpane = new TabbedTablePane();
            tabbedpane.setPreferredSize(new Dimension(500,300));
            
            //Add button bars
            String[] buttonlist = {"Run", "Stop"};
            bp = new JButtonPanel(buttonlist);
            bp.addActionListener(assemdi_frame.get());
            
            //JPanel bottomPane = new JPanel(new BorderLayout());
            status_bar = new JLabel("STATUS");
            tabbedpane.set_statusbar(status_bar);
    
            JPanel bottompane = new JPanel();
            gridbag = new GridBagLayout();
            bottompane.setLayout(gridbag);
            
            c.gridx = 0;
            c.gridy = 0;
            c.weightx = 1;
            c.weighty = 0;
            c.fill = GridBagConstraints.HORIZONTAL;
            bottompane.add(bp, c);
            
            c.gridx = 0;
            c.gridy = 1;
            c.weightx = 1;
            c.weighty = 1;
            c.fill = GridBagConstraints.BOTH;

            bottompane.add(tabbedpane, c);
            
            this.setTopComponent(toppane);
            this.setBottomComponent(bottompane);
            
        } catch (Exception ex) {
            
            ex.printStackTrace();
        }
    }
    
    
    
    public void selectReport() {
        int i = rpt_list.getSelectedIndex();
        if (i < 0)
            return;
        
        
        AReport rpt = rpts[i];
        
        if (rpt == null)
            return;
        
        rpt_desc.setText(rpt.getDesc());
        param_panel.add_params( rpt.getParams() );
       
        //SwingUtilities.getWindowAncestor(this).validate();
        this.validate();
        this.repaint();
        
    }
    
    
    public void actionPerformed(ActionEvent ae) {
        
        String whatsup = ae.getActionCommand();
        
        try {
            if (whatsup.equals("Run")) {
                
                int i_r = rpt_list.getSelectedIndex();
                
                if (i_r < 0)
                    return;
                
                AReport report = rpts[i_r];
                
                if (report == null || report.getSql() == null)
                    return;
                
                //build SQL statement and retrieve
                String commands[] = report.getSql();
                String command = "";
                
                
                for (int i1 = 0; i1 < commands.length; i1++) {
                    
                    String       param_val[];
                    command = commands[i1];
                    
                    for (int i = 0; i < param_panel.get_param_count(); i++) {
                        
                        param_val = param_panel.get_labelparam(i);
                        command = command.replaceAll( param_val[0],
                        param_val[1] );
                    }
                    
                    if (command.length() > 0) {
                        execute_command(command);
                        break;
                    }
                }
                
            } else if (whatsup.equals("Stop")) {
                
                if (asse.dbq.cancelJob(jobid)) {
                    setRunMenu(true);
                }
                return;
            } else if (whatsup.equals("CopyKeys")) {               
                int row = getJTable().getSelectedRow();
                if (row < 0 && getTable().getRowCount() > 0) {
                    row = 0;
                    getJTable().getSelectionModel().setSelectionInterval(0,0);
                }
                    
                if (row >= 0)
                        ExcelAdapter.copy_keys(row, tabbedpane.getCurrentTable());               
                return;
            } else if (whatsup.equals("Copy") ||
                        whatsup.equals("Paste") ||
                        whatsup.equals("Cut")) {
                
                Utilities.do_copycutpaste(whatsup);
             
            } else if (whatsup.equals("Save Table As...")) {
                
                Utilities.save_table(getTable());
                
            } else if (whatsup.equals("Print Table")) {
                
                Utilities.printTable( getJTable() );
                
            } else if (whatsup.equals("CopyTable")) {
                
                ExcelAdapter.copy_to_excel( getJTable());
                return;
                
            } else if (whatsup.equals("Show as Plain Text")) {
                
                ByteArrayOutputStream x = new ByteArrayOutputStream();
                try {
                    PrintTableModel.print(jtable.getModel(),
                    new PrintStream(x));
                    new ErrDialog(null,
                    "Plain Text", x.toString(),
                    "ShowPlainText");
                }
                catch (Exception ex) {
                    new ErrDialog("Save FAILED",ex);
                }
                
            } else {
                JOptionPane.showInternalMessageDialog(this,
                "This event is not programmed yet.",
                whatsup,
                JOptionPane.INFORMATION_MESSAGE);
            }
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
        finally {
            this.repaint();
        }
    }
    
    public myJDBCAdapter getTable() {
        return tabbedpane.getCurrentTable();
    }
    public JTableRowHeader getJTable() {
        return tabbedpane.getCurrentJTable();
    }
    
    public void update_status(String status) {
        status_bar.setText(status);
    }
    
    public void execute_command(final String command) {
        
        if (asse.dbq == null) {
            flag_executing = false;
            setRunMenu(true);
            new ErrDialog( "DATABASE ",  "There is no active database connection. Please connect to database.");
            return;
        }
        
        
        if (flag_executing)
            return;
        
        flag_executing = true;
        setRunMenu(false);
        update_status("Executing..");
        
        final ReportPanel xpane = this;
        
        Runnable dbjob = new Runnable() {
            public void run() {
                jobid = asse.dbq.addJob(command, xpane);
            }
        };
        
        SwingUtilities.invokeLater(dbjob);
    }
    
    public void processResult( final DBQResult dbqr ) {
        
        final AReport report;
        int i_r = rpt_list.getSelectedIndex();
        if (i_r >= 0)
            report = rpts[i_r];
        else
            report = null;
        
        final ReportPanel xpane = this;
        Runnable dbjob
        = new Runnable() {
            public void run() {
                
                boolean flag_norez = true;
                if (dbqr.ezt_array != null) {
                    ezTable[] res = dbqr.ezt_array;
                    if (res != null) {
                        tabbedpane.addTables(res);
                        
                          
                        // Set Column Formats
                        // Set Tab Title
                        for (int tbl = 0;  tbl < tabbedpane.getTabCount(); tbl++) {
                            JTable jtb = tabbedpane.getJTableAt(tbl);
                            for (int col = 0; col < jtb.getColumnCount(); col++) {
                                String colname = jtb.getColumnName(col);
                                String table_title = report.getTableName(colname);
                                if (table_title != null)
                                    tabbedpane.setTitleAt(tbl, table_title);
                                String format_str = report.getFormat(colname);
                                Class  format_class = report.getFormatType(colname);
                                if (format_str != null && format_class != null) {
                                    TableColumn tcm = jtb.getColumn(colname);
                                    tcm.setCellRenderer(  TableCellRendererFactory.get(format_class, format_str) );
                                }
                            }
                       }
                        
                        for (int tbl = 0; tbl < res.length; tbl++) {
                            if (res[tbl].getRowCount() > 0) {
                                flag_norez = false;
                                break;
                            }
                        }
                    }
                }
                if (flag_norez)
                    update_status("No rows returned. Rows affected: "
                    + dbqr.rowcount);
                
                if (dbqr.sqle != null)
                    new ErrDialog( "DATABASE ERROR",  dbqr.sqle );
                
                setRunMenu(true);        
                flag_executing = false;
            }
        };
        
        SwingUtilities.invokeLater(dbjob);
    }
    
     private void setRunMenu (boolean value) {
        bp.setEnabled("Run", value);
        bp.setEnabled("Stop",  value ? false : true);
        jtf.setMenuItem("Run", new Boolean(value));
        jtf.setMenuItem("Stop", new Boolean(value ? false : true));
        jtf.refreshMenu();
    }
}
