/*
 * ReadServerXml.java
 *
 * Created on November 11, 2004, 7:24 PM
 */

package net.sourceforge.asse;

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import java.io.*;
import java.net.URL;

import java.util.*;
/**
 *
 * @author  Manish Shah
 */
public class ServerDefaults {
    
    public static void main(String[] args) {
        try {
            FileReader in = new FileReader(new File(args[0]));
            StringBuffer sb = new StringBuffer();
            int ch;
            while ((ch = in.read())>= 0)
                sb.append(ch);

            ReadConfig (sb.toString());
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    /** Creates a new instance of ReadServerXml */
    public static void ReadConfig(String urlfile) {
        
        try {
            
            URL url = null;
            
            File file = null;
            
            file = new File(urlfile);
            if (!file.exists()) {
                url = new URL(urlfile);
                file = null;
            }
            
            
            SAXBuilder   builder = new SAXBuilder();
            org.jdom.Document doc = null;
            if (file != null)
                doc = builder.build(file);
            else if (url != null)
                doc = builder.build(url);
            
            if (doc == null)
                return;
            
            
            Element root = doc.getRootElement();
            
            java.util.List server_elements = root.getChildren("server");
            
            Iterator server_itr = server_elements.iterator();
            servers.clear();
            
            while (server_itr.hasNext()) {
                
                Element elem = (Element) server_itr.next();
                if (elem != null) {
                    
                    Hashtable serv = new Hashtable();
                    String server_name = elem.getChild("name").getTextTrim();
                    String server_host = elem.getChild("host").getTextTrim();
                    String server_port = elem.getChild("port").getTextTrim();
                    //String server_user = elem.getChild("user").getTextTrim();
                    //String server_pass = elem.getChild("password").getTextTrim();
                   
                    
                    if (server_host != null)
                        serv.put("host", server_host);
                    if (server_port != null)
                        serv.put("port", server_port);
//                    if (server_user != null)
//                        serv.put("user",server_user);
//                    if (server_pass != null)
//                        serv.put("password", server_pass);
//                    
                    servers.put(server_name, serv);
                    
                }
                
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static String getAttrib(String server, String key) {
        Object o  = servers.get(server);
        if (o == null)
            return null;
        Hashtable a = (Hashtable)o;
        
        Object val = a.get(key);
        
        if (val == null)
            return null;
        else
            return val.toString();
        
    }
  
    public static String[] getServerNames() {
        Vector v1 = new Vector();
        for (Enumeration keys = servers.keys(); keys.hasMoreElements();) {
            v1.add(keys.nextElement().toString());
        }
       
        
        Collections.sort( v1, new Comparator() {
            public int compare(Object o1, Object o2) {
                String s1 = (String) o1;
                String s2 = (String) o2;
                return s1.compareTo(s2);
            }
            public boolean equals(Object o1, Object o2) {
                String s1 = (String) o1;
                String s2 = (String) o2;
                return (s1.compareTo(s2) == 0);
            }
        });
        
        String arr[] = new String [v1.size()];
        v1.copyInto(arr);
        return arr;
    }
 
    static Hashtable servers = new Hashtable();
}
