package net.sourceforge.asse;

import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import javax.swing.undo.*;


class SqlMenu extends JMenuBarEx {


    JMenuItem jmi_redo, jmi_undo;

    public SqlMenu () {
	
	JMenuItem jmi;
	JMenu jm = new JMenu("File");
	jm.setMnemonic(KeyEvent.VK_I);
	jm.add(jmi = new JMenuItem("File Save", KeyEvent.VK_S));
	jm.add(jmi = new JMenuItem("File Save As ..", KeyEvent.VK_S));
	jm.add(jmi = new JMenuItem("Insert Query From ..", KeyEvent.VK_R));
	jmi.setToolTipText("Reads SQL into SQLPane from a file.");
	jm.add(jmi = new JMenuItem("Show as Plain Text"));
	jmi.setToolTipText("useful for viewing sp_helptext result.");
	jm.add(jmi = new JMenuItem("Print Table Results"));
	jmi.setToolTipText("Print Table Results.");
	jm.add(jmi = new JMenuItem("Print SQL"));
	jmi.setToolTipText("Print SQL in Pane.");
	jm.add(jmi = new JMenuItem("Save Table As ..", KeyEvent.VK_T));
	jmi.setToolTipText("Save Selected result in a tab-delimited file.");
//	jm.add(jmi = new JMenuItemEx("Exit", KeyEvent.VK_X, KeyEvent.VK_X));
	this.add(jm);

	jm = new JMenu("Edit");
	jm.setMnemonic(KeyEvent.VK_E);
	jm.add(jmi = new JMenuItemEx("Copy", KeyEvent.VK_C, KeyEvent.VK_C));
	jm.add(jmi = new JMenuItemEx("CopyTable", KeyEvent.VK_8, KeyEvent.VK_8));
        jm.add(jmi = new JMenuItemEx("CopyKeys", KeyEvent.VK_8, KeyEvent.VK_8));
	jm.add(jmi = new JMenuItemEx("Cut", KeyEvent.VK_T, KeyEvent.VK_T));
	jm.add(jmi = new JMenuItemEx("Paste", KeyEvent.VK_P, KeyEvent.VK_V));
	jm.add(jmi_undo = new JMenuItem("Undo"));
	jm.add(jmi_redo = new JMenuItem("Redo"));
	jmi_undo.setEnabled(false);
	jmi_redo.setEnabled(false);
	jm.add(jmi = new JMenuItemEx("Select1", KeyEvent.VK_1, KeyEvent.VK_1));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select2", KeyEvent.VK_2, KeyEvent.VK_2 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select3", KeyEvent.VK_3, KeyEvent.VK_3 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select4", KeyEvent.VK_4, KeyEvent.VK_4 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select5", KeyEvent.VK_5, KeyEvent.VK_5 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select6", KeyEvent.VK_6, KeyEvent.VK_6 ));
	jmi.setVisible(false);
	jm.add(jmi = new JMenuItemEx("Select7", KeyEvent.VK_7, KeyEvent.VK_7 ));
	jmi.setVisible(false);
	this.add(jm);

	jm = new JMenu("Query");
	jm.setMnemonic(KeyEvent.VK_Q);
	jm.add(jmi = new JMenuItemEx("Execute", KeyEvent.VK_R, KeyEvent.VK_R));
	jmi.setToolTipText("Execute SQL and Retrieve results");
	jm.add(jmi = new JMenuItemEx("Cancel", KeyEvent.VK_C, 
					KeyEvent.VK_C));
	this.add(jm);
	
	jm = new JMenu("Help");
	jm.setMnemonic(KeyEvent.VK_H);
	jm.add(jmi = new JMenuItem("No_Help_Yet"));
	jmi.setToolTipText("Please see the manual.");
	jm.add(jmi = new JMenuItem("About", KeyEvent.VK_A));

	this.add(jm);
    }
	
    public void setUndoRedoItems ( boolean canUndo, boolean canRedo ) {
	if (canUndo)
	    jmi_undo.setEnabled(true);
	else
	    jmi_undo.setEnabled(false);
	    
	if (canRedo) 
	    jmi_redo.setEnabled(true);
	else
	    jmi_redo.setEnabled(false);
    }
	    

}

