package net.sourceforge.asse;

import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.JTabbedPane;



public class TabbedTablePane extends JTabbedPane {

    myJDBCAdapter     ja[];
    JTableRowHeader   jt[];
    ChangeEvent       chg_event = new ChangeEvent(this);
    JLabel            status_bar;
    Runnable          statusjob;

    ListSelectionListener lslistener = new ListSelectionListener() {
	public void valueChanged(ListSelectionEvent e) {
	    update_status();
	}
    };

    public TabbedTablePane() {
	super();
	addChangeListener( new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    update_status();
		}
	    } );
		    
    }
		
    public void set_statusbar (JLabel jl) {
	status_bar = jl;
    }

    public void addTable ( ezTable ezt) {

	removeAll();

	ja = new myJDBCAdapter [ 1 ];
	jt = new JTableRowHeader [ 1 ];
	ja[0] =  new myJDBCAdapter(ezt);
	jt[0] =  new JTableRowHeader (ja[0]);

	JScrollPane jsp = new JScrollPane( jt[0] ); 
	addTab ("Result", jsp);
    }

    public void addTables (ezTable ezt[]) {

	ListSelectionModel rowSM;
	removeAll();
	
	ja = new myJDBCAdapter [ ezt.length ];
	jt = new JTableRowHeader [ ezt.length ];

	for (int i = 0; i < ezt.length; i++) {
	    int j = i + 1;
	    ja[i] = new myJDBCAdapter( ezt[i]);
 	    jt[i] = new JTableRowHeader( ja[i] );
	    jt[i].setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	    JScrollPane jsp =  jt[i].getScrollPane();
	    jsp.setPreferredSize(new Dimension(500,200));
	    addTab ("Result-" + j, jsp);

	    rowSM = jt[i].getSelectionModel();
	    rowSM.addListSelectionListener(  lslistener );

	}
	update_status();
    }

    public myJDBCAdapter getCurrentTable() {
	int x = getSelectedIndex();
	if (x < 0)
	    return null;

	return getTableAt(x);
    }

    public myJDBCAdapter getTableAt(int index) {
	return ja[index];
    }

    public JTableRowHeader getCurrentJTable() {
	int x = getSelectedIndex();
	if (x < 0)
	    return null;

	return getJTableAt( x );
    }

    public JTableRowHeader getJTableAt(int index) {
	return jt[index];
    }

    public void stopEditing() {
	try {
	    JTable jt = getCurrentJTable();
	    if (jt.isEditing()) {
		jt.editingStopped(chg_event);
	    }
	}
	catch (Exception ex) {
	}
    }

    public void cancelEditing() {
	try {
	    JTable jt = getCurrentJTable();
	    if (jt.isEditing()) {
		jt.editingCanceled(chg_event);
	    }
	}
	catch (Exception ex) {
	}
    }

    public void update_status () {
	if (statusjob == null) 
	    statusjob = new Runnable() {
		    public void run() {
			
			String stat = "STATUS";
			if (getTabCount() > 0) {
			    JTable jt = getCurrentJTable();
			    if (jt != null) {
				int rows = jt.getRowCount();
				int curr  = jt.getSelectedRow() + 1;
				stat = new String ( curr + "/" + rows);
			    }
			}
			if (status_bar != null)
			    status_bar.setText(stat);
		    }
		};

	SwingUtilities.invokeLater(statusjob);
    }
}
	    
// ListSelectionModel rowSM = table.getSelectionModel();
//             rowSM.addListSelectionListener(new ListSelectionListener() {
//                 public void valueChanged(ListSelectionEvent e) {
//                     ListSelectionModel lsm =
//                         (ListSelectionModel)e.getSource();
//                     if (lsm.isSelectionEmpty()) {
//                         ...//no rows are selected
//                     } else {
//                         int selectedRow = lsm.getMinSelectionIndex();
//                         ...//selectedRow is selected
//                     }
//                 }
//             });
