/*
 * TableCellRendererFactory.java
 *
 * Created on December 16, 2004, 10:27 AM
 */

package net.sourceforge.asse;
import java.text.*;
import javax.swing.table.*;
/**
 *
 * @author  manshah
 */
public class TableCellRendererFactory {
    
    /** Creates a new instance of TableCellRendererFactory */
    private TableCellRendererFactory() {
    }
    
    public static javax.swing.table.DefaultTableCellRenderer  get( Class columnClass, String format_str) {
        try {
            if (Class.forName("java.util.Date").isAssignableFrom(columnClass)) {
                SimpleDateFormat _dft;
                try {
                    if (format_str.length() > 0)
                        _dft = new SimpleDateFormat(format_str);
                    else
                        _dft = new SimpleDateFormat();
                } catch (Exception ex) {
                    _dft = new SimpleDateFormat();
                }
                final SimpleDateFormat _dff = _dft;
                
                DefaultTableCellRenderer date_renderer =
                new DefaultTableCellRenderer() {
                    public void setValue(Object value) {
                        if (value == null)
                            setText("");
                        else {
                            try {
                                java.util.Date x_date;
                                if (value instanceof java.util.Date) {
                                    x_date = (java.util.Date)value;
                                    //System.out.println(_df.format(x_date));
                                    setText(_dff.format(x_date));
                                } else {
                                    this.setText(value.toString());
                                }
                            }
                            catch (Exception ex) {
                                ex.printStackTrace();
                                System.out.println(value.toString());
                                setText(value.toString());
                            }
                        }
                    }
                };
                date_renderer.setHorizontalAlignment(javax.swing.JLabel.LEFT);
                return date_renderer;
            }
            if (Class.forName("java.lang.Number").isAssignableFrom(columnClass)) {
                
                DecimalFormat _decft;
                try {
                    _decft = new DecimalFormat(format_str);
                } catch (Exception ex) {
                    _decft = new DecimalFormat("#");
                }
                final DecimalFormat _decff = _decft;
                
                
                DefaultTableCellRenderer decimal_renderer =
                new DefaultTableCellRenderer() {
                    public void setValue(Object value) {
                        if (value == null)
                            setText("");
                        else {
                            try {
                                if (value instanceof Number) {
                                    setText(_decff.format((Number)value));
                                } else {
                                    setText(value.toString());
                                }
                            }
                            catch (Exception ex) {
                                setText(value.toString());
                            }
                        }
                    }
                };
                decimal_renderer.setHorizontalAlignment(javax.swing.JLabel.RIGHT);
                return decimal_renderer;
            }
        } catch (Exception ex) {
            ;
        }
        return new DefaultTableCellRenderer();
    }
}
