
package net.sourceforge.asse;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.text.*;
import java.util.*;
import java.io.*;
import java.sql.*;
import java.awt.print.*;


class  Utilities {
    
    public static TableInfo get_table( String shortname ) {
	
	int pos = 0;
	int dotcount = 0;
	while ((shortname.indexOf(".",pos)) >= 0) {
	    pos = shortname.indexOf(".",pos) + 1;
	    dotcount++;
	}
	
	String db_name = "";
	String owner_name = "";
	String table_name = "";
	
	if (dotcount == 1)  // e.g. "dbo.table"
	    owner_name = shortname.substring(0, shortname.indexOf("."));

	if (dotcount == 2) { // e.g. "dev.dbo.table"
	    db_name = shortname.substring(0, shortname.indexOf("."));
	    owner_name = shortname.substring(db_name.length() + 1, 
					     shortname.lastIndexOf("."));
	    if (db_name.length() == 0)
		return null;// this is an error.
	}

	try {
	    
	    ezTable[] res;
	    if (db_name.equals("")) {
		res = asse.dbq.executeQuery("select db_name() 'dbname' ");
		if (res.length < 1) {
		    System.out.println("Can't even get the database name !");
		    System.exit(1);
		} 
		db_name = res[0].getString(0, 0);
	    }

	    // do sp_help
	    res = asse.dbq.executeQuery (db_name + "..sp_help " + 
				    "'" + shortname + "'");
	
	    // fix user name just in case, it was not given
	    if (res.length > 0) {
		owner_name = res[0].getString(0,"Owner");
		table_name = res[0].getString(0,"Name");

		TableInfo ti;
		ti = TableInfo.get_cached_table(db_name + "." +
						owner_name + "." +
						table_name);
		if( ti != null)
		    return ti;

		// How many columns does this table have ? 
		// This has to match the number returned by sp_help 
		// We are trying to guard against us getting fewer rows
		// when someone has set a rowcount on the connection to a smaller number.
		int col_count = -1;
		ezTable[] res1 = asse.dbq.executeQuery 
		    ("select count(*) 'total' from " + 
		     db_name + "..syscolumns " +
		     " where  id = object_id('" + db_name + "." + owner_name + "." + table_name + "')");

		if (res1.length >= 1)
		    col_count = res1[0].getInt(0,"total");
		
		boolean flag_valid = false;
		for (int i = 0; i < res.length; i++) {
		    int colid = res[i].findColumn("Column_name");
		    if ( colid >= 0) {
			if (res[i].getRowCount() == col_count) 
			    flag_valid = true;
			break;
		    }
		}

		if (!flag_valid) {
		    SQLException ex = new SQLException ("Could not find full table info. Possibly rowcount has been set too low.");
		    throw(ex);
		}
		    
		ti = new TableInfo ( db_name,
				     owner_name,
				     table_name,
				     res );

		return ti;
	    }
	    
	}
	catch (Exception ex) {
	    ex.printStackTrace();
	}

	return null;
	
    }
    public static void save_table (TableModel tabletosave) {

	    
	if (tabletosave != null) {
	    File saveto = PickFile.promptForTableSave("Save Table To");
	    if (saveto != null) {
		try {
		    PrintTableModel.print(tabletosave, 
					  new PrintStream( new FileOutputStream(saveto)));
		}
		catch (Exception ex) {
		    new ErrDialog ("Save FAILED",ex);
		}
	    }
	}

    }
    public static  void do_copycutpaste (String whatsup) {

  	if (whatsup.compareTo("Copy") == 0) {
  	    Component focussed = assemdi_frame.get().getFocusOwner();
  	    if (focussed != null) {
  		if (focussed instanceof JTextComponent) {
  		    JTextComponent jtc_focussed = (JTextComponent) focussed;
  		    jtc_focussed.copy();
  		}
  	    }
  	} else if (whatsup.compareTo("Cut") == 0) {
  	    Component focussed = assemdi_frame.get().getFocusOwner();
  	    if (focussed != null) {
  		if (focussed instanceof JTextComponent) {
  		    JTextComponent jtc_focussed = (JTextComponent) focussed;
  		    jtc_focussed.cut();
  		}
  	    }
  	} else if (whatsup.compareTo("Paste") == 0) {
  	    Component focussed = assemdi_frame.get().getFocusOwner();
  	    if (focussed != null) {
  		if (focussed instanceof JTextComponent) {
  		    JTextComponent jtc_focussed = (JTextComponent) focussed;
  		    jtc_focussed.paste();
  		}
  	    }
	}
    }

    public static void printTable(JTableRowHeader table_toprint) {

  	    PrinterJob pj = PrinterJob.getPrinterJob();
  	    PageFormat pf = pj.pageDialog(pj.defaultPage());
  	    pj.setPrintable(table_toprint, pf);
 	    if (pj.printDialog()) {
  		try { pj.print(); }
  		catch (PrinterException pe) {
  		    System.out.println(pe);
  		}
  	    }
    }
}
