package net.sourceforge.asse;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

class asselogin  
    extends javax.swing.JDialog
    implements ActionListener, 
	       //ListSelectionListener, 
	       AdjustmentListener {

    JComboBox server_jlist;
    JlistParams jlist_params;
    Param [] params;
    DwbjServer [] servers;
    String failed_server = "";
    int    fail_count = 0;

    public asselogin (JFrame frame)  {

	super (frame, "Login", true);
	setDefaultCloseOperation(DISPOSE_ON_CLOSE);

	getContentPane().setLayout( new BorderLayout());

	
	servers = DwbjServer.loadServers();
	String [] server_names = new String [ servers.length + 1];
	server_names[0] = "NEW SERVER";
	Vector sl = getSortedServerList();
	for (int i = 0; i < sl.size(); i++) 
	    server_names[i+1] = (String)sl.elementAt(i);

	server_jlist = new JComboBox ( server_names );
	server_jlist.setSelectedIndex(servers.length);
	server_jlist.addActionListener( new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    serverChanged();
		}
	    } );
	
	//JScrollPane server_jlist_pane = new JScrollPane(server_jlist);
	//server_jlist_pane.getVerticalScrollBar().addAdjustmentListener(this);

	getContentPane().add(server_jlist, BorderLayout.NORTH);
	params = new Param[5]; // login, pass, host, port
	params[0] = new Param ("SERVER");
	params[1] = new Param ("LOGIN");
	params[2] = new Param ("PASSWORD", "", true);
	params[3] = new Param ("HOST");
	params[4] = new Param ("PORT");

	jlist_params = new JlistParams(params);
	getContentPane().add(jlist_params, BorderLayout.CENTER);

	jchkbox = new JCheckBox("Save Password [unsafe]",false);
		
	cb_login = new JButton("Connect");
	cb_login.addActionListener(this);	
	cb_cancel = new JButton("Cancel");
	cb_cancel.addActionListener(this);	

	JPanel jp = new JPanel( new BorderLayout() );
	jp.add (jchkbox, BorderLayout.NORTH);
	jp.add (cb_login);
	jp.add (cb_cancel, BorderLayout.SOUTH);
	getContentPane().add(jp, BorderLayout.SOUTH);

	setSize(DwbjProps.getIntProperty("asseloginwidth", 185),
		DwbjProps.getIntProperty("asseloginheight", 210));
    
	setLocationRelativeTo(frame);

	this.addWindowListener(new WindowAdapter() { 
		public void windowActivated(WindowEvent evt) {

		    String lastserver = DwbjProps.getProperty("SERVER-0");
		    if (lastserver != null) {
			server_jlist.setSelectedItem (lastserver);
			server_jlist.requestFocus();
			//focusOnButton();//okbutton.requestFocus();
		    } else {
			jlist_params.get_text_field(0).requestFocus();
		    }
		}
		
		private void focusOnButton() {
		    Runnable doit = new Runnable() {
			    public void run() {
				cb_login.requestFocus();
			    }
			};
		    
		    try {
			SwingUtilities.invokeLater(doit);
		    }
		    catch (Exception ex) {
			ex.printStackTrace();
		    }
		}
	    } 
			       ); 
	
	JTextField f = jlist_params.get_text_field(0);
	KeyStroke enter = KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, 0); 
	javax.swing.text.Keymap map = f.getKeymap(); 
	map.removeKeyStrokeBinding(enter); 

	//serverChanged();
	if ( asse.dbexecq != null) {
	    setTitle("Connected");
	    cb_login.setText("Disconnect");
	}

	getRootPane().setDefaultButton(cb_login);
	this.show();	

    }
  
    public void actionPerformed (ActionEvent ae) {

	String whatsup = ae.getActionCommand();

	if (whatsup.compareTo("Cancel") == 0) {
	    this.setVisible(false);
	    this.dispose();
	}
	if (whatsup.compareTo("Connect") == 0) {
	    connect_to_db();
	}
	if (whatsup.compareTo("Disconnect") == 0) {
	    disconnect_to_db();
	}

    }

    private void disconnect_to_db() {

	if (asse.dbexecq != null) {
	    asse.dbexecq.close();
	    asse.dbexecq = null;
	    asse.dbh     = null;
	    asse.dbq     = null;
	}
	cb_login.setText("Connect");
	setTitle("Login");
    }

    private void connect_to_db() {

	String server_name = jlist_params.get_param("SERVER");

	if (server_name.trim().length() < 1 ) {
	    setTitle("SERVER Required.");
	    return;
	}

	setCursor(new Cursor(Cursor.WAIT_CURSOR));

	DBMulti  dbh = new DBMulti (  
				    jlist_params.get_param("HOST"),
				    jlist_params.get_param("PORT") ,
				    jlist_params.get_param("LOGIN"),
				    jlist_params.get_param("PASSWORD"),
				    "", //proxy
				    "asse"
			);
	
	if (dbh.get_connection() == null) {
	    if (failed_server.compareTo(jlist_params.get_param("SERVER"))
		== 0)
		fail_count++;
	    else {
		fail_count = 1;
		failed_server = jlist_params.get_param("SERVER");
	    }
	    if (fail_count >= 5) {
		setTitle("failed #" + fail_count + " -Will remove.");
		failed.put (jlist_params.get_param("SERVER"), "failed");
	    } else
		setTitle("Login failed. #" + fail_count);

	    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	    System.out.println("Login failed. #" + fail_count);
	
	    return;
	}

	failed.remove(jlist_params.get_param("SERVER"));
	assemdi_frame.get().setTitle(jlist_params.get_param("SERVER"));
	setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	
	disconnect_to_db();

	asse.dbh = dbh;
	asse.dbh.set_debug(true);
	asse.dbq = new DBQueue(dbh);
	asse.dbexecq = new DBExecutor(
				      asse.dbq,
				      asse.dbh,
				      new asse_DBML()
					  );

	asse.dbexecq.start();

	DwbjServer.unloadServers(); //removes from property.
	
	DwbjServer good = new DwbjServer ( 
				    jlist_params.get_param("SERVER"),
				    jlist_params.get_param("LOGIN"),
				    jchkbox.isSelected() ?
				    jlist_params.get_param("PASSWORD") : "",
				    jlist_params.get_param("HOST"),
				    jlist_params.get_param("PORT") );
	
	DwbjProps.setProperty("SERVER-0", jlist_params.get_param("SERVER"));
	good.saveToProps();

	int saved = 1;
	for (int i = 0; i < servers.length; i++) {
	    Object flag_failed;
	    flag_failed = failed.get( servers[i].getName() );
	    if (flag_failed != null)
		continue;
	    
	    if (servers[i].getName().compareTo(good.getName()) ==0)
		continue;

	    if (saved++ >= 10)
		break;
	    DwbjProps.setProperty(new String("SERVER-" + saved), 
				  servers[i].getName());
	    servers[i].saveToProps();
	}

	this.setVisible(false);
	this.dispose();

    }
    
    public void adjustmentValueChanged(AdjustmentEvent e) {

//  	int x = server_jlist.getLastVisibleIndex();
//  	if (x >= 0 && x != server_jlist.getSelectedIndex()) {
//  	    server_jlist.setSelectedIndex(x);
//  	}
    }

    private void serverChanged () {
	String sname = (String)server_jlist.getSelectedItem();
	
	if (sname.compareTo("NEW SERVER") == 0) {
		jlist_params.set_param( "SERVER", "");
		jlist_params.set_param( "LOGIN", "");
		jlist_params.set_param( "PASSWORD", "");
		jlist_params.set_param( "HOST", "");
		jlist_params.set_param( "PORT", "");
		return;
	}
	    
	for (int i = 0; i < servers.length; i++) {
	    if (servers[i].getName().compareTo(sname) == 0) {
		jlist_params.set_param( "SERVER", servers[i].getName());
		jlist_params.set_param( "LOGIN", servers[i].getLogin());
		jlist_params.set_param( "PASSWORD", servers[i].getPassword());
		jlist_params.set_param( "HOST", servers[i].getHost());
		jlist_params.set_param( "PORT", servers[i].getPort());
		break;
	    }
	}

	if (jlist_params.get_param("PASSWORD").length() > 0) 
	    jchkbox.setSelected(true);
	else
	    jchkbox.setSelected(false);

	//this.setTitle("Login");
    }

    private Vector getSortedServerList() {
	Vector v1 = new Vector();
	for (int i = 0; i < servers.length; i++) 
	    v1.add( servers[i].getName());

	Collections.sort( v1, new Comparator () {
		public int compare (Object o1, Object o2) {
		    String s1 = (String) o1;
		    String s2 = (String) o2;
		    return s1.compareTo(s2);
		}
		public boolean equals (Object o1, Object o2) {
		    String s1 = (String) o1;
		    String s2 = (String) o2;
		    return (s1.compareTo(s2) == 0);
		}		    
	    });
	return v1;
    }
	    
    JTextArea jt;
    static int            sheight =0;
    static int            swidth =0;
    Hashtable             failed = new Hashtable();
    boolean               flag_transferred = true;
    JButton               cb_login;
    JButton               cb_cancel;
    JComponent            preferred_first_component;
    JCheckBox             jchkbox;
    
}




