package net.sourceforge.asse;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class assemdi_frame extends JFrame
implements  ActionListener {
    
    static assemdi_frame mdi_frame;
    
    public static assemdi_frame get() {
        return mdi_frame;
    }
    
    void initSize() {
        
        
        Dimension x = Toolkit.getDefaultToolkit().getScreenSize();
        startWidth = (int) (x.getWidth() * .80);
        startHeight = (int) (x.getHeight() * .80);
        
        startWidth  = DwbjProps.getIntProperty("asseframewidth", 0);
        startHeight = DwbjProps.getIntProperty("asseframeheight",0);
        if (startWidth == 0 || startHeight == 0) {
            System.out.println("Did not find them. !");
            startWidth = (int) (x.getWidth() * .80);
            startHeight = (int) (x.getHeight() * .80);
        }
        
        setSize( startWidth, startHeight);
        
        setTitle("AniSa - Not connected");
        setLocation( (int)((x.getWidth() - startWidth)/2),
        (int)((x.getHeight() - startHeight)/2) );
        
    }
    
    
    public assemdi_frame() {
        //new LogFiles("assemdi");
        AsseGlobal.init("AniSa.dat");
        initComponents();
        initSize();
        initLogin();
        mdi_frame = this;
        
        //openLogWindow();
        
    }
    
    private void initLogin() {
        
        final assemdi_frame x = this;
        addWindowListener(new WindowAdapter() {
            
            boolean first_time = true;
            public void windowActivated(WindowEvent evt) {
                
                if (first_time)
                    first_time = false;
                else
                    return;
                
                Runnable doit = new Runnable() {
                    public void run() {
                        x.actionPerformed(
                        new ActionEvent(x,
                        ActionEvent.ACTION_PERFORMED,
                        "Connect to Database")
                        );
                        x.openLogWindow();
                    }
                };
                
                try {
                    SwingUtilities.invokeLater(doit);
                }
                catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        });
    }
    
    private void initComponents() {
        
        desktopPane = new javax.swing.JDesktopPane();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm();
            }
        });
        
        getContentPane().add(desktopPane, java.awt.BorderLayout.CENTER);
        
        frameMenu = new FrameMenu(desktopPane, this);
        setJMenuBar(frameMenu);
        frameMenu.addActionListener(this);
        
        
        pack();
        
    }
    
    public void exitForm() {
        
        DwbjProps.setIntProperty("asseframewidth", getWidth());
        DwbjProps.setIntProperty("asseframeheight",getHeight());
        
        //orderly shutdown preserves SQL files.
        JInternalFrame [] frames = desktopPane.getAllFrames();
        for (int i = frames.length - 1;  i >= 0; i-- )
            frames[i].doDefaultCloseAction();
        
        AsseGlobal.shutdown();
        System.exit(1);
    }
    
    public void actionPerformed(ActionEvent ae) {
        String whatsup;
        
        whatsup = ae.getActionCommand();
        
        if (whatsup.compareTo("Exit") == 0) {
            int x = JOptionPane.showConfirmDialog(assemdi_frame.get(),
            "Do you want to Exit ?",
            "AniSa",
            JOptionPane.YES_NO_OPTION,
            JOptionPane.WARNING_MESSAGE);
            if (x == JOptionPane.YES_OPTION)
                exitForm();
            else
                return;
        } else if (whatsup.compareTo("Cascade Windows") == 0) {
            cascadeWindows();
        } else if (whatsup.compareTo("Tile Windows") == 0) {
            tileWindows();
        } else if (whatsup.compareTo("Close Window") == 0) {
            JInternalFrame ifrm = desktopPane.getSelectedFrame();
            if (ifrm != null)
                ifrm.doDefaultCloseAction();
        } else if (whatsup.compareTo("Toggle Windows") == 0) {
            JInternalFrame list[]= desktopPane.getAllFrames();
            JInternalFrame ifrm = desktopPane.getSelectedFrame();
            int pos;
            if (ifrm != null) {
                for (pos = 0; pos < list.length; pos++) {
                    if (list[pos] == ifrm) {
                        pos++;
                        if (pos == list.length)
                            pos = 0;
                        if (list[pos].isIcon())
                            pos++;
                        if (pos == list.length)
                            pos = 0;                       
                        try {
                            list[pos].setSelected(true);
                            list[pos].toFront();
                        } 
                        catch (Exception ex) { 
                        }
                        
                        break;
                    } 
                }
            }
        } else if (whatsup.compareTo("Cycle Windows") == 0) {
            JInternalFrame list[]= desktopPane.getAllFrames();
            JInternalFrame ifrm = desktopPane.getSelectedFrame();
            int pos;
            if (ifrm != null) {
                for (pos = list.length - 1; pos >= 0; pos--) {
                    if (list[pos] == ifrm) {
                        pos--;
                        if (pos < 0)  
                            pos = list.length - 1;
                        if (list[pos].isIcon())
                            pos--;
                        if (pos < 0)  
                            pos = list.length - 1;
                        
                        try {
                            list[pos].setSelected(true);
                            list[pos].toFront();
                        } 
                        catch (Exception ex) { 
                            ex.printStackTrace();
                        }
                        break;
                    } 
                }
            }
        } else if (whatsup.compareTo("Open SQL file") == 0) {
            
            java.io.File sqlfile = PickFile.promptForSQLFile("Open SQL File");
            if (sqlfile == null)
                return;
            try {
                openSQLFile(sqlfile);
            } catch (IOException ex) {
                ex.printStackTrace();
            }
            
        } else if (whatsup.compareTo("Open Report") == 0) {
            java.io.File xmlfile = PickFile.promptForXMLFile("Open Report File");
            if (xmlfile == null)
                return;
            
            
            openReport(xmlfile);
        } else if (whatsup.compareTo("Open Schema") == 0) {
            
            JSchemaFrame j = new JSchemaFrame();
            desktopPane.add(j);
            j.show();
            frameMenu.refresh_windowmenu();
            
        } else if (whatsup.compareTo("Open Table") == 0) {
            
            String tname;
            tname = JOptionPane.showInputDialog(
            assemdi_frame.get(),
            "Table to open",
            DwbjProps.getProperty("LastTableOpened", ""));
            
            if (tname != null && tname.length() > 0) {
                DwbjProps.setProperty("LastTableOpened", tname);
                openTable(tname);
            }
            
        } else if (whatsup.endsWith(":Open Table:")) {
            
            String tname;
            tname = whatsup.substring(0, whatsup.indexOf(":Open Table:"));
            
            if (tname != null && tname.length() > 0)
                openTable(tname);
            
        } else if (whatsup.endsWith(":Open File:")) {
            
            String fname;
            fname = whatsup.substring(0, whatsup.indexOf(":Open File:"));
            
            if (fname != null && fname.length() > 0)
                try {
                    openSQLFile(new java.io.File(fname));
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            
        } else if (whatsup.endsWith(":Open Report:")) {
            
            String fname;
            fname = whatsup.substring(0, whatsup.indexOf(":Open Report:"));
            
            if (fname != null && fname.length() > 0)
                openReport(new java.io.File(fname));
            
        } else if (whatsup.compareTo("Connect to Database") == 0) {
            
            JDialog jd = new LoginDialog(this, true);
            jd.show();
            
        } else if (whatsup.compareTo("About") == 0) {
            
            new AboutAsse();
            
        } else if (whatsup.compareTo("Recent..") == 0) {
            
            new RecentAccess(this,
            this,
            AsseGlobal.recentFiles,
            AsseGlobal.recentTables,
            AsseGlobal.recentReports
            );
            
        } else if (whatsup.compareTo("Set Options...") ==0) {
            JDialog jd = new OptionsDialog(this, true);
            jd.show();
            
        } else if (whatsup.compareTo("Read Servers From...") == 0) {
            String file_or_url = JOptionPane.showInputDialog("Please provide full path File or full URL for Servers.xml");
            if (file_or_url != null)
                ServerDefaults.ReadConfig(file_or_url);
        } else {
            JInternalFrame ifrm = desktopPane.getSelectedFrame();
            if (ifrm != null && ifrm instanceof ActionListener ) {
                ActionListener alistener = (ActionListener) ifrm;
                
                alistener.actionPerformed(ae);
            } else
                System.out.println("'" + whatsup + "'");
        }
    }
    
    public  JInternalFrame locateTitleFrame(String title) {
        JInternalFrame [] frames = desktopPane.getAllFrames();
        for (int i = 0; i < frames.length; i++ ) {
            if (frames[i].getTitle().compareTo(title) == 0)
                return frames[i];
        }
        return null;
    }
    
    public void openReport(File xmlfile) {
        
        if (xmlfile == null)
            return;
        
        try {
            
            AReport[] rpts  = ReadReportXml.getReports( xmlfile );
            
            
            if (rpts.length < 1 || rpts[0] == null) {
                throw (new Exception("No reports. !"));
            }
            
            System.out.println(rpts[0].toString());
            
            ReportFrame reportframe = new ReportFrame("REPORTS:"+xmlfile.getName(),
            rpts); {
                int index;
                index = AsseGlobal.recentReports.indexOf(xmlfile);
                if (index >= 0)
                    AsseGlobal.recentReports.remove(index);
                AsseGlobal.recentReports.add(0, xmlfile);
                if (AsseGlobal.recentReports.size() > 10)
                    AsseGlobal.recentReports.setSize(10);
            }
            
            desktopPane.add(reportframe);
            reportframe.show();
            frameMenu.refresh_windowmenu();
        }
        catch (Exception ex) {
            new ErrDialog("Report Error", ex);
        }
    }
    
    private void openLogWindow()  {
        JAppLogFrame logFrame = new JAppLogFrame();
        desktopPane.add(logFrame);
        
        
        setFrameLocation(logFrame);
        frameMenu.refresh_windowmenu();
        
        try {
            logFrame.setIcon(true);
        } catch (Exception ex) {
            ;
        }
    }
    public void openSQLFile(File sqlfile) throws IOException {
        
        
        if (sqlfile == null)
            return;
        
        JInternalFrame sqlframe;
        sqlframe = locateTitleFrame("ISQL:" + sqlfile.getCanonicalPath());
        if (sqlframe != null) {
            try {
                sqlframe.setIcon(false);
                sqlframe.setSelected(true);
                sqlframe.toFront();
            }
            catch (Exception ex) {}
        } else {
            try {
                if (sqlfile.exists() ||
                sqlfile.createNewFile()) {
                    sqlframe = new JSQLFrame(sqlfile);
                    
                    {
                        int index;
                        index = AsseGlobal.recentFiles.indexOf(sqlfile);
                        if (index >= 0)
                            AsseGlobal.recentFiles.remove(index);
                        AsseGlobal.recentFiles.add(0, sqlfile);
                        if (AsseGlobal.recentFiles.size() > 10)
                            AsseGlobal.recentFiles.setSize(10);
                    }
                    
                    desktopPane.add(sqlframe);
                    setFrameLocation(sqlframe);
                    
                    frameMenu.refresh_windowmenu();
                }
            } catch (java.io.IOException ex) {
                System.out.println("Can not create/open file.");
            }
        }
    }
    
    public void refresh_windowmenu() {
        frameMenu.refresh_windowmenu();
    }
    
    public void openTable(String tname) {
        
        TableInfo ti;
        JInternalFrame tableFrame;
        
        if ((tableFrame = locateTitleFrame("TABLE:"+tname)) != null) {
                try {
                    tableFrame.setIcon(false);
                    tableFrame.setSelected(true);
                    tableFrame.toFront();
                    
                }
                catch (Exception ex) { }
                return;
        }   
        ti = Utilities.get_table(tname);
        if (ti != null) {
            
            tname = ti.getTableName();
            tableFrame = locateTitleFrame("TABLE:"+ ti.getTableName());
            if (tableFrame != null) {
                try {
                    tableFrame.setIcon(false);
                    tableFrame.setSelected(true);
                    tableFrame.toFront();
                    
                }
                catch (Exception ex) { }
            } else {
                try {
                    tableFrame = new JTableFrame(ti);
                    
                    {
                        int index;
                        index = AsseGlobal.recentTables.indexOf(tname);
                        if (index >= 0)
                            AsseGlobal.recentTables.remove(index);
                        
                        AsseGlobal.recentTables.add(0, tname);
                        if (AsseGlobal.recentTables.size() > 10)
                            AsseGlobal.recentTables.setSize(10);
                    }
                    
                    desktopPane.add(tableFrame);
                    setFrameLocation(tableFrame);
                    frameMenu.refresh_windowmenu();
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
            
        } else {
            Object[] options = { "OK"};
            JOptionPane.showOptionDialog(this.get(), "Table does not exist..", "Warning",
            JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,null, options, options[0]);
            
        }
    }
    
    private void setFrameLocation( JInternalFrame iframe ) {
        // position frame
        int width = desktopPane.getWidth() / 2;
        int height = desktopPane.getHeight() / 2;
        iframe.reshape(nextFrameX, nextFrameY, iframe.getWidth(), iframe.getHeight());
        
        iframe.show();
        
        if (frameDistance == 0)
            frameDistance = iframe.getHeight()
            - iframe.getContentPane().getHeight();
        
        // compute placement for next frame
        
        nextFrameX += frameDistance;
        nextFrameY += frameDistance;
        if (nextFrameX + width > desktopPane.getWidth())
            nextFrameX = 0;
        if (nextFrameY + height > desktopPane.getHeight())
            nextFrameY = 0;
    }
    
    public void cascadeWindows() {
        JInternalFrame[] frames = desktopPane.getAllFrames();
        int x = 0;
        int y = 0;
        int width = (int) (desktopPane.getWidth() * 0.7) ;
        int height = (int) (desktopPane.getHeight() * 0.7);
        
        for (int i = 0; i < frames.length; i++) {
            if (!frames[i].isIcon()) {
                try {  /* try to make maximized frames resizable
                                  this might be vetoed
                 */
                    frames[i].setMaximum(false);
                    frames[i].reshape(x, y,
                    width,
                    height
                    );
                    
                    x += frameDistance;
                    y += frameDistance;
                    // wrap around at the desktopPane edge
                    if (x + width > desktopPane.getWidth()) x = 0;
                    if (y + height > desktopPane.getHeight()) y = 0;
                    frames[i].toFront();
                    frames[i].setSelected(true);
                }
                catch(Exception e)
                {}
            }
        }
    }
    
    public void tileWindows() {
        JInternalFrame[] frames = desktopPane.getAllFrames();
        
        // count frames that aren't iconized
        int frameCount = 0;
        for (int i = 0; i < frames.length; i++)
        {  if (!frames[i].isIcon())
               frameCount++;
        }
        
        int rows = (int)Math.sqrt(frameCount);
        int cols = frameCount / rows;
        int extra = frameCount % rows;
        // number of columns with an extra row
        
        int width = desktopPane.getWidth() / cols;
        int height = desktopPane.getHeight() / rows;
        int r = 0;
        int c = 0;
        for (int i = 0; i < frames.length; i++)
        {  if (!frames[i].isIcon())
           {  try
              {  frames[i].setMaximum(false);
                 frames[i].reshape(c * width,
                 r * height, width, height);
                 r++;
                 if (r == rows)
                 {  r = 0;
                    c++;
                    if (c == cols - extra) {  // start adding an extra row
                        rows++;
                        height = desktopPane.getHeight() / rows;
                    }
                 }
              }
              catch(Exception e)
              {}
           }
        }
    }
    
    public void selectNextWindow() {
        JInternalFrame[] frames = desktopPane.getAllFrames();
        for (int i = 0; i < frames.length; i++)
        {  if (frames[i].isSelected()) {  /* find next frame that isn't an icon and can be
                      selected
         */
               try
               {  int next = i + 1;
                  while (next != i && frames[next].isIcon())
                      next++;
                  if (next == i) return;
                  // all other frames are icons or veto selection
                  frames[next].setSelected(true);
                  frames[next].toFront();
                  return;
               }
               catch(Exception e)
               {}
           }
        }
    }
    
    
//    public static void main(String args[]) {
//                  if (args.length > 0)
//                ServerDefaults.ReadConfig(args[0]);
//        final assemdi_frame fm = new assemdi_frame();
//        
//        //  	Runnable dbconnect =
//        //  	    new Runnable() {
//        //  		    public void run() {
//        //  			fm.actionPerformed(new ActionEvent(this,
//        //  							   ActionEvent.ACTION_PERFORMED,
//        //  							   "Connect to Database"));
//        //  		    }
//        //  		};
//        
//        //  	SwingUtilities.invokeLater(dbconnect);
//        
//        fm.show();
//        
//    }
    
    private FrameMenu                frameMenu;
    private javax.swing.JDesktopPane desktopPane;
    
    private int                      nextFrameX = 0;
    private int                      nextFrameY = 0;
    private int                      frameDistance;
    private int                      startWidth, startHeight;
    
}
