package net.sourceforge.asse;

import java.util.Date;
import java.util.Vector;
import javax.swing.table.*;
import java.sql.*;
import java.io.*;

// Eazy table, basically a  DefaultTableModel
//

public class ezTable extends DefaultTableModel { 

    public ezTable ( ezTable src) {
	super(src.getRowCount(), src.getColumnCount());

	Vector datavec = new Vector();

	for (int row = 0; row < src.getRowCount(); row++) {
	    Vector rowvec = new Vector();
	    for (int col = 0; col < src.getColumnCount(); col++) {
		rowvec.addElement( src.getValueAt(row, col) );
	    }
	    datavec.addElement(rowvec);
	}

	Vector colnames = new Vector();
	for (int j = 0; j < src.getColumnCount(); j++) {
	    colnames.addElement(src.getColumnName(j));
	}
	
	setDataVector(datavec, colnames);
 	colTypeNames = (String [])src.colTypeNames.clone();
    }

    public ezTable ( int Rows, int Cols ) {
	super (Rows, Cols);
	for (int i=0; i < Rows; i++) {
	    for (int j=0; j < Cols; j++) {
		setValueAt( new Integer(i+j), i, j);
	    }
	}
  	colTypeNames = new String [ Cols ];
  	for (int i=0; i < Cols; i++) {
  	    colTypeNames [i] = "int";
  	}
    }
    public ezTable ( Vector data, Vector columnNames, Vector pcolumnTypeNames ) 
    {
	super (data, columnNames);
 	colTypeNames = new String [pcolumnTypeNames.size() ];
 	pcolumnTypeNames.copyInto(colTypeNames);
    }

    public void print() {
	print (new PrintStream(System.out));
    }
    public void print(PrintStream prn) {

	try {
	    int rows;
	    int cols;
	    String colsep = "";
	    String linesep = "\n";
	    
	    
	    rows = getRowCount();
	    cols = getColumnCount();
	    
	    //printing column names
	    for (int i=0; i < cols; i++) {
		prn.print(colsep + getColumnName(i));
		colsep = "|";
	    }
	    prn.print(linesep);
	
//  	    if (rows > 0) {
//  		colsep = "";
//  		for (int i=0; i < cols; i++) {
//  		    prn.print(getValueAt(0,i).getClass().getName());
//  		    colsep = "|";
//  		}
//  	    }

	    for (int i=0; i < rows; i++) {
		colsep = "";
		for (int j=0; j < cols; j++) {
		    prn.print(colsep + getValueAt(i, j));
		    colsep = "|";
		}
		prn.print(linesep);
	    }
  	} 
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
  public void printHtmlTable(PrintStream prn) {

	try {
	    int rows;
	    int cols;
	    String colsep = "";
	    String linesep = "\n";
	    
	    
	    rows = getRowCount();
	    cols = getColumnCount();
	    
            prn.print("<TABLE><TR>");
	    //printing column names
	    for (int i=0; i < cols; i++) {
		prn.print("<TH>" + getColumnName(i) + "</TH>");
		
	    }
	    prn.println("</TR>");

	    for (int i=0; i < rows; i++) {
		prn.print("<TR>");
		for (int j=0; j < cols; j++) {
                    if (getValueAt(i, j) == null)
                        prn.print("<TD></TD>");
                    else
                        prn.print("<TD>" + getValueAt(i, j) +"</TD>");

		}
		prn.println("</TR>");
	    }
            prn.println("</TABLE>");
  	} 
	catch (Exception ex) {
	    ex.printStackTrace();
	}
    }
    public String getString ( int row, String colname ) {
	return getString( row, findColumn(colname) ) ;
    }
    public String getString ( int row, int col ) {
	Object obj;

	try {
	    obj = getValueAt( row, col );
	    if (obj == null) {
		return null;
	    }
    
	    if (obj instanceof String) {
		return (String) obj;
	    }
    
	    return obj.toString();
	}

	catch (Exception ex) {
	    return null;
	}
    }
  

    public int getInt (int row, String colname ) {
	return getInt (row, findColumn(colname));
    }
    public int getInt (int row, int col) {
	Object obj;

	try {
	    obj = getValueAt( row, col );
      
	    if (obj instanceof Number) {
		return ((Number)obj).intValue();
	    }	

	    if (obj instanceof String) {
		return Integer.parseInt((String)obj);
	    }
	    if (obj instanceof Boolean) {
		if (((Boolean)obj).booleanValue()) 
		    return 1;
		else
		    return 0;
	    }
	} catch (Exception ex) {
	    ex.printStackTrace();
	    ;
	}
	return Integer.MIN_VALUE;
    }


    public float getFloat (int row, String colname ) {
	return getFloat (row, findColumn(colname));
    }
    public float getFloat (int row, int col) {
	Object obj;

	try {
	    obj = getValueAt( row, col );
      
	    if (obj instanceof Number) {
		return ((Number)obj).floatValue();
	    }	

	    if (obj instanceof String) {
		return Float.parseFloat((String)obj);
	    }
	} catch (Exception ex) {
	    ;      
	}
	return Float.MIN_VALUE;
    }
  
    public String[] getColTypeNames() {
	
	String[] coltypes = new String[ getColumnCount() ];
	for (int i = 0; i < coltypes.length; i++ ) {
	    coltypes[i] = colTypeNames[i];
	}
	
	return coltypes;
    }

    public void setValueAt ( Object value, int row, String colname ) {
	setValueAt ( value, row, findColumn(colname));
    }
    
    public Timestamp getTimestamp (int row, String colname ) {
	return getTimestamp (row, findColumn(colname));
    }
    public Timestamp getTimestamp(int row, int col) {
	Object obj;

	try {
	    obj = getValueAt( row, col );
      
	    if (obj instanceof Timestamp) {
		return (Timestamp) obj;
	    } else if (obj instanceof String) {
		return Timestamp.valueOf((String)obj);
	    }
	} catch (Exception ex) {
	     ;      
	}
	return new Timestamp(0);
    }
	
    public String getColTypeName(int i) {	
	return colTypeNames[i];
    }

    
    public void sort (int Column, boolean Ascending) {
	int columns[] = new int [1];
	boolean columnsorder[] = new boolean[1];
	
	columns[0] = Column;
	columnsorder[0] = Ascending;
	
	sort (columns, columnsorder);
    }
    
	
    public void sort (int ColumnList[], boolean ascending[]) {
	ezTableSorter sorter = new ezTableSorter(this);
	sorter.setSortingColumns(ColumnList, ascending);
	
	int neworder[] = sorter.sort();

	Vector newdatavec = new Vector();
	Vector curdatavec = getDataVector();

	if (neworder.length != curdatavec.size())
	    return; //something wrong.

	for (int row = 0; row < neworder.length; row++) 
	    newdatavec.add( curdatavec.elementAt( neworder[row] ) );

	Vector colnames = new Vector();
	for (int j = 0; j < getColumnCount(); j++) {
	    colnames.addElement(getColumnName(j));
	}
	
	setDataVector(newdatavec, colnames);
	    
	    
    }
//      public void attach_TableInfo(TableInfo ti) {
//  	table_info = ti;
//      }

    String [] colTypeNames;
//      TableInfo  table_info;

}


